"""Autogenerated API schema"""
from argus_api import session


add_template_comment = {'tags': ['configurationadmin'], 'summary': 'Add a comment to a configuration template (INTERNAL)', 'description': '', 'operationId': 'addTemplateComment', 'consumes': ['text/plain'], 'produces': ['application/json'], 'parameters': [{'in': 'body', 'name': 'body', 'description': 'Comment', 'required': False, 'schema': {'type': 'string'}}, {'name': 'id', 'in': 'path', 'description': 'ID of template to add comment to', 'required': True, 'type': 'int'}], 'responses': {'201': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'required': ['codeProfile', 'name', 'shortName'], 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'name': {'type': 'str', 'position': 0, 'description': 'A unique name for this template'}, 'mnemonic': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: The shortname for this template'}, 'shortName': {'type': 'str', 'position': 0, 'description': 'The shortname for this template'}, 'configurationData': {'type': 'str', 'position': 0, 'description': 'The XML configuration for this template. May be null in search result if includeConfiguration is set to false, or if configurationResource is set.'}, 'configurationResource': {'type': 'str', 'position': 0, 'description': 'The configuration resource to load for this template. Is not set if template has explicit configuration data (XML)'}, 'properties': {'type': 'dict', 'position': 0, 'description': 'The properties set for this template. May be null in search result if includeProperties is set to false.', 'additionalProperties': {'type': 'string'}}, 'startupIndex': {'type': 'int', 'position': 0, 'description': 'The startup index for this template. When automatically starting instances, the startup ordering is determined by startupIndex.'}, 'revision': {'type': 'int', 'position': 0, 'description': 'The revision index for the current template configuration. This is bumped on every change to the template.'}, 'masterID': {'type': 'int', 'position': 0, 'description': 'If this object represents a configuration revision, this is the ID of the master instance configuration which is currently the latest revision.'}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was last updated.'}, 'codeProfile': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'deleted': {'type': 'boolean'}, 'finalized': {'type': 'boolean'}, 'name': {'type': 'str', 'position': 0, 'description': 'The name of this profile'}, 'created': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was created'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was last updated. Profiles which are finalized cannot be updated.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'artifacts': {'type': 'list', 'position': 0, 'description': 'The list of artifacts in this profile. May be null when searching for profiles, unless includeArtifacts is true', 'items': {'type': 'dict', 'properties': {'id': {'type': 'string'}, 'flags': {'type': 'int'}, 'groupID': {'type': 'str', 'position': 0, 'description': 'The MVN groupID'}, 'artifactID': {'type': 'str', 'position': 0, 'description': 'The MVN artifactID'}, 'version': {'type': 'str', 'position': 0, 'description': 'The MVN version'}, 'status': {'type': 'str', 'position': 0, 'description': 'The artifacts status. Can only be deleted if UNUSED.', 'enum': ['UNUSED', 'ACTIVE', 'DELETED']}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was last updated.'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'length': {'type': 'int', 'position': 0, 'description': 'The size of this artifact (in bytes).'}, 'data': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: This field is always null'}}, 'description': 'Describes a code artifact, typically a JAR file, which is available for download. The ID of the artifact is the SHA256-sum of the file.'}}}, 'description': 'A profile is a specific bundle of code artifacts. Non-finalized profiles cannot be used in templates, only in specific instances.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'information': {'type': 'str', 'position': 0, 'description': 'Informational text about this configuration (plain text, default sanitation).'}, 'dependsOn': {'type': 'dict', 'required': ['codeProfile', 'name', 'shortName'], 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'name': {'type': 'str', 'position': 0, 'description': 'A unique name for this template'}, 'mnemonic': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: The shortname for this template'}, 'shortName': {'type': 'str', 'position': 0, 'description': 'The shortname for this template'}, 'configurationData': {'type': 'str', 'position': 0, 'description': 'The XML configuration for this template. May be null in search result if includeConfiguration is set to false, or if configurationResource is set.'}, 'configurationResource': {'type': 'str', 'position': 0, 'description': 'The configuration resource to load for this template. Is not set if template has explicit configuration data (XML)'}, 'properties': {'type': 'dict', 'position': 0, 'description': 'The properties set for this template. May be null in search result if includeProperties is set to false.', 'additionalProperties': {'type': 'string'}}, 'startupIndex': {'type': 'int', 'position': 0, 'description': 'The startup index for this template. When automatically starting instances, the startup ordering is determined by startupIndex.'}, 'revision': {'type': 'int', 'position': 0, 'description': 'The revision index for the current template configuration. This is bumped on every change to the template.'}, 'masterID': {'type': 'int', 'position': 0, 'description': 'If this object represents a configuration revision, this is the ID of the master instance configuration which is currently the latest revision.'}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was last updated.'}, 'codeProfile': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'deleted': {'type': 'boolean'}, 'finalized': {'type': 'boolean'}, 'name': {'type': 'str', 'position': 0, 'description': 'The name of this profile'}, 'created': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was created'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was last updated. Profiles which are finalized cannot be updated.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'artifacts': {'type': 'list', 'position': 0, 'description': 'The list of artifacts in this profile. May be null when searching for profiles, unless includeArtifacts is true', 'items': {'type': 'dict', 'properties': {'id': {'type': 'string'}, 'flags': {'type': 'int'}, 'groupID': {'type': 'str', 'position': 0, 'description': 'The MVN groupID'}, 'artifactID': {'type': 'str', 'position': 0, 'description': 'The MVN artifactID'}, 'version': {'type': 'str', 'position': 0, 'description': 'The MVN version'}, 'status': {'type': 'str', 'position': 0, 'description': 'The artifacts status. Can only be deleted if UNUSED.', 'enum': ['UNUSED', 'ACTIVE', 'DELETED']}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was last updated.'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'length': {'type': 'int', 'position': 0, 'description': 'The size of this artifact (in bytes).'}, 'data': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: This field is always null'}}, 'description': 'Describes a code artifact, typically a JAR file, which is available for download. The ID of the artifact is the SHA256-sum of the file.'}}}, 'description': 'A profile is a specific bundle of code artifacts. Non-finalized profiles cannot be used in templates, only in specific instances.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'information': {'type': 'str', 'position': 0, 'description': 'Informational text about this configuration (plain text, default sanitation).'}, 'dependsOn': [], 'comments': {'type': 'list', 'position': 0, 'description': 'The comments configuration for this template. Is null in search result unless includeComments is set to true.', 'items': {'type': 'dict', 'properties': {'timestamp': {'type': 'int', 'position': 0, 'description': 'When the comment was added.'}, 'user': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'comment': {'type': 'str', 'position': 0, 'description': "The comment's text."}}}}, 'encodedFlags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'DISABLED_MONITORING']}}}, 'description': 'Represents a configuration template, defining which code, configuration and default properties an instance should use.'}, 'comments': {'type': 'list', 'position': 0, 'description': 'The comments configuration for this template. Is null in search result unless includeComments is set to true.', 'items': {'type': 'dict', 'properties': {'timestamp': {'type': 'int', 'position': 0, 'description': 'When the comment was added.'}, 'user': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'comment': {'type': 'str', 'position': 0, 'description': "The comment's text."}}}}, 'encodedFlags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'DISABLED_MONITORING']}}}, 'description': 'Represents a configuration template, defining which code, configuration and default properties an instance should use.'}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation error'}}}
create_template = {'tags': ['configurationadmin'], 'summary': 'Create new configuration template (INTERNAL)', 'description': '', 'operationId': 'createTemplate', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'in': 'body', 'name': 'body', 'description': 'Create request', 'required': False, 'schema': {'type': 'object', 'required': ['codeProfile', 'name', 'shortName'], 'properties': {'name': {'type': 'str', 'position': 0, 'description': 'A unique name for this template => [a-zA-Z0-9_:\\-\\.]*'}, 'shortName': {'type': 'str', 'position': 0, 'description': 'A unique shortname for this template => [a-zA-Z0-9_:\\-\\.]*'}, 'mnemonic': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: A unique shortname for this template. Use shortName instead. => [a-zA-Z0-9_:\\-\\.]*'}, 'configuration': {'type': 'str', 'position': 0, 'description': 'The configuration XML to use for this template. One of configuration and configurationResource is required. => format:xml'}, 'configurationResource': {'type': 'str', 'position': 0, 'description': 'Name of configuration resource (class name or classpath to Spring XML. One of configuration and configurationResource is required. The resource must exist in the classpath of the code profile.'}, 'properties': {'type': 'dict', 'position': 0, 'description': 'Configuration properties to use for this template, with default values. Values may be overridden on host or instance', 'additionalProperties': {'type': 'string'}}, 'information': {'type': 'str', 'position': 0, 'description': 'Informational text about this template. Default sanitation. => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'dependsOnID': {'type': 'int', 'position': 0, 'description': 'If set, this declares the ID of the template that this template requires as parent. Instances must be created with another instance with template dependsOnID as parent.', 'minimum': 0}, 'startupIndex': {'type': 'int', 'position': 0, 'description': 'Specify the startup order of this component (default 0)', 'minimum': 0, 'default': 0}, 'codeProfile': {'type': 'str', 'position': 0, 'description': 'The code profile to use when running this template => [a-zA-Z0-9_:\\-\\.]*'}}, 'description': 'Request to add a new template'}}], 'responses': {'201': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'required': ['codeProfile', 'name', 'shortName'], 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'name': {'type': 'str', 'position': 0, 'description': 'A unique name for this template'}, 'mnemonic': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: The shortname for this template'}, 'shortName': {'type': 'str', 'position': 0, 'description': 'The shortname for this template'}, 'configurationData': {'type': 'str', 'position': 0, 'description': 'The XML configuration for this template. May be null in search result if includeConfiguration is set to false, or if configurationResource is set.'}, 'configurationResource': {'type': 'str', 'position': 0, 'description': 'The configuration resource to load for this template. Is not set if template has explicit configuration data (XML)'}, 'properties': {'type': 'dict', 'position': 0, 'description': 'The properties set for this template. May be null in search result if includeProperties is set to false.', 'additionalProperties': {'type': 'string'}}, 'startupIndex': {'type': 'int', 'position': 0, 'description': 'The startup index for this template. When automatically starting instances, the startup ordering is determined by startupIndex.'}, 'revision': {'type': 'int', 'position': 0, 'description': 'The revision index for the current template configuration. This is bumped on every change to the template.'}, 'masterID': {'type': 'int', 'position': 0, 'description': 'If this object represents a configuration revision, this is the ID of the master instance configuration which is currently the latest revision.'}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was last updated.'}, 'codeProfile': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'deleted': {'type': 'boolean'}, 'finalized': {'type': 'boolean'}, 'name': {'type': 'str', 'position': 0, 'description': 'The name of this profile'}, 'created': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was created'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was last updated. Profiles which are finalized cannot be updated.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'artifacts': {'type': 'list', 'position': 0, 'description': 'The list of artifacts in this profile. May be null when searching for profiles, unless includeArtifacts is true', 'items': {'type': 'dict', 'properties': {'id': {'type': 'string'}, 'flags': {'type': 'int'}, 'groupID': {'type': 'str', 'position': 0, 'description': 'The MVN groupID'}, 'artifactID': {'type': 'str', 'position': 0, 'description': 'The MVN artifactID'}, 'version': {'type': 'str', 'position': 0, 'description': 'The MVN version'}, 'status': {'type': 'str', 'position': 0, 'description': 'The artifacts status. Can only be deleted if UNUSED.', 'enum': ['UNUSED', 'ACTIVE', 'DELETED']}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was last updated.'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'length': {'type': 'int', 'position': 0, 'description': 'The size of this artifact (in bytes).'}, 'data': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: This field is always null'}}, 'description': 'Describes a code artifact, typically a JAR file, which is available for download. The ID of the artifact is the SHA256-sum of the file.'}}}, 'description': 'A profile is a specific bundle of code artifacts. Non-finalized profiles cannot be used in templates, only in specific instances.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'information': {'type': 'str', 'position': 0, 'description': 'Informational text about this configuration (plain text, default sanitation).'}, 'dependsOn': {'type': 'dict', 'required': ['codeProfile', 'name', 'shortName'], 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'name': {'type': 'str', 'position': 0, 'description': 'A unique name for this template'}, 'mnemonic': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: The shortname for this template'}, 'shortName': {'type': 'str', 'position': 0, 'description': 'The shortname for this template'}, 'configurationData': {'type': 'str', 'position': 0, 'description': 'The XML configuration for this template. May be null in search result if includeConfiguration is set to false, or if configurationResource is set.'}, 'configurationResource': {'type': 'str', 'position': 0, 'description': 'The configuration resource to load for this template. Is not set if template has explicit configuration data (XML)'}, 'properties': {'type': 'dict', 'position': 0, 'description': 'The properties set for this template. May be null in search result if includeProperties is set to false.', 'additionalProperties': {'type': 'string'}}, 'startupIndex': {'type': 'int', 'position': 0, 'description': 'The startup index for this template. When automatically starting instances, the startup ordering is determined by startupIndex.'}, 'revision': {'type': 'int', 'position': 0, 'description': 'The revision index for the current template configuration. This is bumped on every change to the template.'}, 'masterID': {'type': 'int', 'position': 0, 'description': 'If this object represents a configuration revision, this is the ID of the master instance configuration which is currently the latest revision.'}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was last updated.'}, 'codeProfile': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'deleted': {'type': 'boolean'}, 'finalized': {'type': 'boolean'}, 'name': {'type': 'str', 'position': 0, 'description': 'The name of this profile'}, 'created': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was created'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was last updated. Profiles which are finalized cannot be updated.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'artifacts': {'type': 'list', 'position': 0, 'description': 'The list of artifacts in this profile. May be null when searching for profiles, unless includeArtifacts is true', 'items': {'type': 'dict', 'properties': {'id': {'type': 'string'}, 'flags': {'type': 'int'}, 'groupID': {'type': 'str', 'position': 0, 'description': 'The MVN groupID'}, 'artifactID': {'type': 'str', 'position': 0, 'description': 'The MVN artifactID'}, 'version': {'type': 'str', 'position': 0, 'description': 'The MVN version'}, 'status': {'type': 'str', 'position': 0, 'description': 'The artifacts status. Can only be deleted if UNUSED.', 'enum': ['UNUSED', 'ACTIVE', 'DELETED']}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was last updated.'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'length': {'type': 'int', 'position': 0, 'description': 'The size of this artifact (in bytes).'}, 'data': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: This field is always null'}}, 'description': 'Describes a code artifact, typically a JAR file, which is available for download. The ID of the artifact is the SHA256-sum of the file.'}}}, 'description': 'A profile is a specific bundle of code artifacts. Non-finalized profiles cannot be used in templates, only in specific instances.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'information': {'type': 'str', 'position': 0, 'description': 'Informational text about this configuration (plain text, default sanitation).'}, 'dependsOn': [], 'comments': {'type': 'list', 'position': 0, 'description': 'The comments configuration for this template. Is null in search result unless includeComments is set to true.', 'items': {'type': 'dict', 'properties': {'timestamp': {'type': 'int', 'position': 0, 'description': 'When the comment was added.'}, 'user': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'comment': {'type': 'str', 'position': 0, 'description': "The comment's text."}}}}, 'encodedFlags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'DISABLED_MONITORING']}}}, 'description': 'Represents a configuration template, defining which code, configuration and default properties an instance should use.'}, 'comments': {'type': 'list', 'position': 0, 'description': 'The comments configuration for this template. Is null in search result unless includeComments is set to true.', 'items': {'type': 'dict', 'properties': {'timestamp': {'type': 'int', 'position': 0, 'description': 'When the comment was added.'}, 'user': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'comment': {'type': 'str', 'position': 0, 'description': "The comment's text."}}}}, 'encodedFlags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'DISABLED_MONITORING']}}}, 'description': 'Represents a configuration template, defining which code, configuration and default properties an instance should use.'}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation error'}}}
delete_template = {'tags': ['configurationadmin'], 'summary': 'Delete configuration template (INTERNAL)', 'description': '', 'operationId': 'deleteTemplate', 'produces': ['application/json'], 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of template to delete', 'required': True, 'type': 'int'}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'required': ['codeProfile', 'name', 'shortName'], 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'name': {'type': 'str', 'position': 0, 'description': 'A unique name for this template'}, 'mnemonic': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: The shortname for this template'}, 'shortName': {'type': 'str', 'position': 0, 'description': 'The shortname for this template'}, 'configurationData': {'type': 'str', 'position': 0, 'description': 'The XML configuration for this template. May be null in search result if includeConfiguration is set to false, or if configurationResource is set.'}, 'configurationResource': {'type': 'str', 'position': 0, 'description': 'The configuration resource to load for this template. Is not set if template has explicit configuration data (XML)'}, 'properties': {'type': 'dict', 'position': 0, 'description': 'The properties set for this template. May be null in search result if includeProperties is set to false.', 'additionalProperties': {'type': 'string'}}, 'startupIndex': {'type': 'int', 'position': 0, 'description': 'The startup index for this template. When automatically starting instances, the startup ordering is determined by startupIndex.'}, 'revision': {'type': 'int', 'position': 0, 'description': 'The revision index for the current template configuration. This is bumped on every change to the template.'}, 'masterID': {'type': 'int', 'position': 0, 'description': 'If this object represents a configuration revision, this is the ID of the master instance configuration which is currently the latest revision.'}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was last updated.'}, 'codeProfile': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'deleted': {'type': 'boolean'}, 'finalized': {'type': 'boolean'}, 'name': {'type': 'str', 'position': 0, 'description': 'The name of this profile'}, 'created': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was created'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was last updated. Profiles which are finalized cannot be updated.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'artifacts': {'type': 'list', 'position': 0, 'description': 'The list of artifacts in this profile. May be null when searching for profiles, unless includeArtifacts is true', 'items': {'type': 'dict', 'properties': {'id': {'type': 'string'}, 'flags': {'type': 'int'}, 'groupID': {'type': 'str', 'position': 0, 'description': 'The MVN groupID'}, 'artifactID': {'type': 'str', 'position': 0, 'description': 'The MVN artifactID'}, 'version': {'type': 'str', 'position': 0, 'description': 'The MVN version'}, 'status': {'type': 'str', 'position': 0, 'description': 'The artifacts status. Can only be deleted if UNUSED.', 'enum': ['UNUSED', 'ACTIVE', 'DELETED']}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was last updated.'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'length': {'type': 'int', 'position': 0, 'description': 'The size of this artifact (in bytes).'}, 'data': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: This field is always null'}}, 'description': 'Describes a code artifact, typically a JAR file, which is available for download. The ID of the artifact is the SHA256-sum of the file.'}}}, 'description': 'A profile is a specific bundle of code artifacts. Non-finalized profiles cannot be used in templates, only in specific instances.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'information': {'type': 'str', 'position': 0, 'description': 'Informational text about this configuration (plain text, default sanitation).'}, 'dependsOn': {'type': 'dict', 'required': ['codeProfile', 'name', 'shortName'], 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'name': {'type': 'str', 'position': 0, 'description': 'A unique name for this template'}, 'mnemonic': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: The shortname for this template'}, 'shortName': {'type': 'str', 'position': 0, 'description': 'The shortname for this template'}, 'configurationData': {'type': 'str', 'position': 0, 'description': 'The XML configuration for this template. May be null in search result if includeConfiguration is set to false, or if configurationResource is set.'}, 'configurationResource': {'type': 'str', 'position': 0, 'description': 'The configuration resource to load for this template. Is not set if template has explicit configuration data (XML)'}, 'properties': {'type': 'dict', 'position': 0, 'description': 'The properties set for this template. May be null in search result if includeProperties is set to false.', 'additionalProperties': {'type': 'string'}}, 'startupIndex': {'type': 'int', 'position': 0, 'description': 'The startup index for this template. When automatically starting instances, the startup ordering is determined by startupIndex.'}, 'revision': {'type': 'int', 'position': 0, 'description': 'The revision index for the current template configuration. This is bumped on every change to the template.'}, 'masterID': {'type': 'int', 'position': 0, 'description': 'If this object represents a configuration revision, this is the ID of the master instance configuration which is currently the latest revision.'}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was last updated.'}, 'codeProfile': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'deleted': {'type': 'boolean'}, 'finalized': {'type': 'boolean'}, 'name': {'type': 'str', 'position': 0, 'description': 'The name of this profile'}, 'created': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was created'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was last updated. Profiles which are finalized cannot be updated.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'artifacts': {'type': 'list', 'position': 0, 'description': 'The list of artifacts in this profile. May be null when searching for profiles, unless includeArtifacts is true', 'items': {'type': 'dict', 'properties': {'id': {'type': 'string'}, 'flags': {'type': 'int'}, 'groupID': {'type': 'str', 'position': 0, 'description': 'The MVN groupID'}, 'artifactID': {'type': 'str', 'position': 0, 'description': 'The MVN artifactID'}, 'version': {'type': 'str', 'position': 0, 'description': 'The MVN version'}, 'status': {'type': 'str', 'position': 0, 'description': 'The artifacts status. Can only be deleted if UNUSED.', 'enum': ['UNUSED', 'ACTIVE', 'DELETED']}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was last updated.'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'length': {'type': 'int', 'position': 0, 'description': 'The size of this artifact (in bytes).'}, 'data': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: This field is always null'}}, 'description': 'Describes a code artifact, typically a JAR file, which is available for download. The ID of the artifact is the SHA256-sum of the file.'}}}, 'description': 'A profile is a specific bundle of code artifacts. Non-finalized profiles cannot be used in templates, only in specific instances.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'information': {'type': 'str', 'position': 0, 'description': 'Informational text about this configuration (plain text, default sanitation).'}, 'dependsOn': [], 'comments': {'type': 'list', 'position': 0, 'description': 'The comments configuration for this template. Is null in search result unless includeComments is set to true.', 'items': {'type': 'dict', 'properties': {'timestamp': {'type': 'int', 'position': 0, 'description': 'When the comment was added.'}, 'user': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'comment': {'type': 'str', 'position': 0, 'description': "The comment's text."}}}}, 'encodedFlags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'DISABLED_MONITORING']}}}, 'description': 'Represents a configuration template, defining which code, configuration and default properties an instance should use.'}, 'comments': {'type': 'list', 'position': 0, 'description': 'The comments configuration for this template. Is null in search result unless includeComments is set to true.', 'items': {'type': 'dict', 'properties': {'timestamp': {'type': 'int', 'position': 0, 'description': 'When the comment was added.'}, 'user': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'comment': {'type': 'str', 'position': 0, 'description': "The comment's text."}}}}, 'encodedFlags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'DISABLED_MONITORING']}}}, 'description': 'Represents a configuration template, defining which code, configuration and default properties an instance should use.'}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation error'}}}
duplicate_template = {'tags': ['configurationadmin'], 'summary': 'Create a duplicate of a configuration template (INTERNAL)', 'description': '', 'operationId': 'duplicateTemplate', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of template to duplicate', 'required': True, 'type': 'int'}], 'responses': {'201': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'required': ['codeProfile', 'name', 'shortName'], 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'name': {'type': 'str', 'position': 0, 'description': 'A unique name for this template'}, 'mnemonic': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: The shortname for this template'}, 'shortName': {'type': 'str', 'position': 0, 'description': 'The shortname for this template'}, 'configurationData': {'type': 'str', 'position': 0, 'description': 'The XML configuration for this template. May be null in search result if includeConfiguration is set to false, or if configurationResource is set.'}, 'configurationResource': {'type': 'str', 'position': 0, 'description': 'The configuration resource to load for this template. Is not set if template has explicit configuration data (XML)'}, 'properties': {'type': 'dict', 'position': 0, 'description': 'The properties set for this template. May be null in search result if includeProperties is set to false.', 'additionalProperties': {'type': 'string'}}, 'startupIndex': {'type': 'int', 'position': 0, 'description': 'The startup index for this template. When automatically starting instances, the startup ordering is determined by startupIndex.'}, 'revision': {'type': 'int', 'position': 0, 'description': 'The revision index for the current template configuration. This is bumped on every change to the template.'}, 'masterID': {'type': 'int', 'position': 0, 'description': 'If this object represents a configuration revision, this is the ID of the master instance configuration which is currently the latest revision.'}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was last updated.'}, 'codeProfile': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'deleted': {'type': 'boolean'}, 'finalized': {'type': 'boolean'}, 'name': {'type': 'str', 'position': 0, 'description': 'The name of this profile'}, 'created': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was created'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was last updated. Profiles which are finalized cannot be updated.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'artifacts': {'type': 'list', 'position': 0, 'description': 'The list of artifacts in this profile. May be null when searching for profiles, unless includeArtifacts is true', 'items': {'type': 'dict', 'properties': {'id': {'type': 'string'}, 'flags': {'type': 'int'}, 'groupID': {'type': 'str', 'position': 0, 'description': 'The MVN groupID'}, 'artifactID': {'type': 'str', 'position': 0, 'description': 'The MVN artifactID'}, 'version': {'type': 'str', 'position': 0, 'description': 'The MVN version'}, 'status': {'type': 'str', 'position': 0, 'description': 'The artifacts status. Can only be deleted if UNUSED.', 'enum': ['UNUSED', 'ACTIVE', 'DELETED']}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was last updated.'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'length': {'type': 'int', 'position': 0, 'description': 'The size of this artifact (in bytes).'}, 'data': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: This field is always null'}}, 'description': 'Describes a code artifact, typically a JAR file, which is available for download. The ID of the artifact is the SHA256-sum of the file.'}}}, 'description': 'A profile is a specific bundle of code artifacts. Non-finalized profiles cannot be used in templates, only in specific instances.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'information': {'type': 'str', 'position': 0, 'description': 'Informational text about this configuration (plain text, default sanitation).'}, 'dependsOn': {'type': 'dict', 'required': ['codeProfile', 'name', 'shortName'], 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'name': {'type': 'str', 'position': 0, 'description': 'A unique name for this template'}, 'mnemonic': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: The shortname for this template'}, 'shortName': {'type': 'str', 'position': 0, 'description': 'The shortname for this template'}, 'configurationData': {'type': 'str', 'position': 0, 'description': 'The XML configuration for this template. May be null in search result if includeConfiguration is set to false, or if configurationResource is set.'}, 'configurationResource': {'type': 'str', 'position': 0, 'description': 'The configuration resource to load for this template. Is not set if template has explicit configuration data (XML)'}, 'properties': {'type': 'dict', 'position': 0, 'description': 'The properties set for this template. May be null in search result if includeProperties is set to false.', 'additionalProperties': {'type': 'string'}}, 'startupIndex': {'type': 'int', 'position': 0, 'description': 'The startup index for this template. When automatically starting instances, the startup ordering is determined by startupIndex.'}, 'revision': {'type': 'int', 'position': 0, 'description': 'The revision index for the current template configuration. This is bumped on every change to the template.'}, 'masterID': {'type': 'int', 'position': 0, 'description': 'If this object represents a configuration revision, this is the ID of the master instance configuration which is currently the latest revision.'}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was last updated.'}, 'codeProfile': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'deleted': {'type': 'boolean'}, 'finalized': {'type': 'boolean'}, 'name': {'type': 'str', 'position': 0, 'description': 'The name of this profile'}, 'created': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was created'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was last updated. Profiles which are finalized cannot be updated.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'artifacts': {'type': 'list', 'position': 0, 'description': 'The list of artifacts in this profile. May be null when searching for profiles, unless includeArtifacts is true', 'items': {'type': 'dict', 'properties': {'id': {'type': 'string'}, 'flags': {'type': 'int'}, 'groupID': {'type': 'str', 'position': 0, 'description': 'The MVN groupID'}, 'artifactID': {'type': 'str', 'position': 0, 'description': 'The MVN artifactID'}, 'version': {'type': 'str', 'position': 0, 'description': 'The MVN version'}, 'status': {'type': 'str', 'position': 0, 'description': 'The artifacts status. Can only be deleted if UNUSED.', 'enum': ['UNUSED', 'ACTIVE', 'DELETED']}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was last updated.'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'length': {'type': 'int', 'position': 0, 'description': 'The size of this artifact (in bytes).'}, 'data': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: This field is always null'}}, 'description': 'Describes a code artifact, typically a JAR file, which is available for download. The ID of the artifact is the SHA256-sum of the file.'}}}, 'description': 'A profile is a specific bundle of code artifacts. Non-finalized profiles cannot be used in templates, only in specific instances.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'information': {'type': 'str', 'position': 0, 'description': 'Informational text about this configuration (plain text, default sanitation).'}, 'dependsOn': [], 'comments': {'type': 'list', 'position': 0, 'description': 'The comments configuration for this template. Is null in search result unless includeComments is set to true.', 'items': {'type': 'dict', 'properties': {'timestamp': {'type': 'int', 'position': 0, 'description': 'When the comment was added.'}, 'user': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'comment': {'type': 'str', 'position': 0, 'description': "The comment's text."}}}}, 'encodedFlags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'DISABLED_MONITORING']}}}, 'description': 'Represents a configuration template, defining which code, configuration and default properties an instance should use.'}, 'comments': {'type': 'list', 'position': 0, 'description': 'The comments configuration for this template. Is null in search result unless includeComments is set to true.', 'items': {'type': 'dict', 'properties': {'timestamp': {'type': 'int', 'position': 0, 'description': 'When the comment was added.'}, 'user': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'comment': {'type': 'str', 'position': 0, 'description': "The comment's text."}}}}, 'encodedFlags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'DISABLED_MONITORING']}}}, 'description': 'Represents a configuration template, defining which code, configuration and default properties an instance should use.'}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation error'}}}
get_template_configuration_data = {'tags': ['configurationadmin'], 'summary': 'Fetch configuration template configuration data (INTERNAL)', 'description': '', 'operationId': 'getTemplateConfigurationData', 'produces': ['application/json'], 'parameters': [{'name': 'idOrShortname', 'in': 'path', 'description': 'ID or shortname of template', 'required': True, 'type': 'str'}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'templateID': {'type': 'int'}, 'flags': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['referenced', 'inline']}}, 'data': {'type': 'string'}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation error'}}}
get_template_properties = {'tags': ['configurationadmin'], 'summary': 'Fetch configuration template properties (INTERNAL)', 'description': '', 'operationId': 'getTemplateProperties', 'produces': ['application/json'], 'parameters': [{'name': 'idOrShortname', 'in': 'path', 'description': 'ID or shortname of template', 'required': True, 'type': 'str'}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'required': ['name'], 'properties': {'name': {'type': 'str', 'position': 0, 'description': 'Name of this property'}, 'value': {'type': 'str', 'position': 0, 'description': 'Set value of this property'}, 'defaultValue': {'type': 'str', 'position': 0, 'description': 'Default value of this property'}, 'source': {'type': 'str', 'position': 0, 'description': 'The origin of this property (the source of the current value)', 'enum': ['config', 'template', 'host', 'instance']}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation error'}}}
list_templates = {'tags': ['configurationadmin'], 'summary': 'List configuration templates (INTERNAL)', 'description': '', 'operationId': 'listTemplates', 'produces': ['application/json'], 'parameters': [{'name': 'search', 'in': 'query', 'description': 'Keyword search string', 'required': False, 'type': 'str'}, {'name': 'includeComments', 'in': 'query', 'description': 'If true, also include comments on every returned search result', 'required': False, 'type': 'bool', 'default': False}, {'name': 'includeDeleted', 'in': 'query', 'description': 'If true, also include templates marked as deleted', 'required': False, 'type': 'bool', 'default': False}, {'name': 'offset', 'in': 'query', 'description': 'Skip the first matching results', 'required': False, 'type': 'int', 'default': 0}, {'name': 'limit', 'in': 'query', 'description': 'Return a limited number of results', 'required': False, 'type': 'int', 'default': 25}, {'name': 'orderBy', 'in': 'query', 'description': 'Sort results', 'required': False, 'type': 'str', 'default': 'name', 'enum': ['id', 'name']}, {'name': 'orderDesc', 'in': 'query', 'description': 'Sort results descending', 'required': False, 'type': 'bool'}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'required': ['codeProfile', 'name', 'shortName'], 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'name': {'type': 'str', 'position': 0, 'description': 'A unique name for this template'}, 'mnemonic': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: The shortname for this template'}, 'shortName': {'type': 'str', 'position': 0, 'description': 'The shortname for this template'}, 'configurationData': {'type': 'str', 'position': 0, 'description': 'The XML configuration for this template. May be null in search result if includeConfiguration is set to false, or if configurationResource is set.'}, 'configurationResource': {'type': 'str', 'position': 0, 'description': 'The configuration resource to load for this template. Is not set if template has explicit configuration data (XML)'}, 'properties': {'type': 'dict', 'position': 0, 'description': 'The properties set for this template. May be null in search result if includeProperties is set to false.', 'additionalProperties': {'type': 'string'}}, 'startupIndex': {'type': 'int', 'position': 0, 'description': 'The startup index for this template. When automatically starting instances, the startup ordering is determined by startupIndex.'}, 'revision': {'type': 'int', 'position': 0, 'description': 'The revision index for the current template configuration. This is bumped on every change to the template.'}, 'masterID': {'type': 'int', 'position': 0, 'description': 'If this object represents a configuration revision, this is the ID of the master instance configuration which is currently the latest revision.'}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was last updated.'}, 'codeProfile': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'deleted': {'type': 'boolean'}, 'finalized': {'type': 'boolean'}, 'name': {'type': 'str', 'position': 0, 'description': 'The name of this profile'}, 'created': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was created'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was last updated. Profiles which are finalized cannot be updated.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'artifacts': {'type': 'list', 'position': 0, 'description': 'The list of artifacts in this profile. May be null when searching for profiles, unless includeArtifacts is true', 'items': {'type': 'dict', 'properties': {'id': {'type': 'string'}, 'flags': {'type': 'int'}, 'groupID': {'type': 'str', 'position': 0, 'description': 'The MVN groupID'}, 'artifactID': {'type': 'str', 'position': 0, 'description': 'The MVN artifactID'}, 'version': {'type': 'str', 'position': 0, 'description': 'The MVN version'}, 'status': {'type': 'str', 'position': 0, 'description': 'The artifacts status. Can only be deleted if UNUSED.', 'enum': ['UNUSED', 'ACTIVE', 'DELETED']}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was last updated.'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'length': {'type': 'int', 'position': 0, 'description': 'The size of this artifact (in bytes).'}, 'data': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: This field is always null'}}, 'description': 'Describes a code artifact, typically a JAR file, which is available for download. The ID of the artifact is the SHA256-sum of the file.'}}}, 'description': 'A profile is a specific bundle of code artifacts. Non-finalized profiles cannot be used in templates, only in specific instances.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'information': {'type': 'str', 'position': 0, 'description': 'Informational text about this configuration (plain text, default sanitation).'}, 'dependsOn': {'type': 'dict', 'required': ['codeProfile', 'name', 'shortName'], 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'name': {'type': 'str', 'position': 0, 'description': 'A unique name for this template'}, 'mnemonic': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: The shortname for this template'}, 'shortName': {'type': 'str', 'position': 0, 'description': 'The shortname for this template'}, 'configurationData': {'type': 'str', 'position': 0, 'description': 'The XML configuration for this template. May be null in search result if includeConfiguration is set to false, or if configurationResource is set.'}, 'configurationResource': {'type': 'str', 'position': 0, 'description': 'The configuration resource to load for this template. Is not set if template has explicit configuration data (XML)'}, 'properties': {'type': 'dict', 'position': 0, 'description': 'The properties set for this template. May be null in search result if includeProperties is set to false.', 'additionalProperties': {'type': 'string'}}, 'startupIndex': {'type': 'int', 'position': 0, 'description': 'The startup index for this template. When automatically starting instances, the startup ordering is determined by startupIndex.'}, 'revision': {'type': 'int', 'position': 0, 'description': 'The revision index for the current template configuration. This is bumped on every change to the template.'}, 'masterID': {'type': 'int', 'position': 0, 'description': 'If this object represents a configuration revision, this is the ID of the master instance configuration which is currently the latest revision.'}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was last updated.'}, 'codeProfile': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'deleted': {'type': 'boolean'}, 'finalized': {'type': 'boolean'}, 'name': {'type': 'str', 'position': 0, 'description': 'The name of this profile'}, 'created': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was created'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was last updated. Profiles which are finalized cannot be updated.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'artifacts': {'type': 'list', 'position': 0, 'description': 'The list of artifacts in this profile. May be null when searching for profiles, unless includeArtifacts is true', 'items': {'type': 'dict', 'properties': {'id': {'type': 'string'}, 'flags': {'type': 'int'}, 'groupID': {'type': 'str', 'position': 0, 'description': 'The MVN groupID'}, 'artifactID': {'type': 'str', 'position': 0, 'description': 'The MVN artifactID'}, 'version': {'type': 'str', 'position': 0, 'description': 'The MVN version'}, 'status': {'type': 'str', 'position': 0, 'description': 'The artifacts status. Can only be deleted if UNUSED.', 'enum': ['UNUSED', 'ACTIVE', 'DELETED']}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was last updated.'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'length': {'type': 'int', 'position': 0, 'description': 'The size of this artifact (in bytes).'}, 'data': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: This field is always null'}}, 'description': 'Describes a code artifact, typically a JAR file, which is available for download. The ID of the artifact is the SHA256-sum of the file.'}}}, 'description': 'A profile is a specific bundle of code artifacts. Non-finalized profiles cannot be used in templates, only in specific instances.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'information': {'type': 'str', 'position': 0, 'description': 'Informational text about this configuration (plain text, default sanitation).'}, 'dependsOn': [], 'comments': {'type': 'list', 'position': 0, 'description': 'The comments configuration for this template. Is null in search result unless includeComments is set to true.', 'items': {'type': 'dict', 'properties': {'timestamp': {'type': 'int', 'position': 0, 'description': 'When the comment was added.'}, 'user': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'comment': {'type': 'str', 'position': 0, 'description': "The comment's text."}}}}, 'encodedFlags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'DISABLED_MONITORING']}}}, 'description': 'Represents a configuration template, defining which code, configuration and default properties an instance should use.'}, 'comments': {'type': 'list', 'position': 0, 'description': 'The comments configuration for this template. Is null in search result unless includeComments is set to true.', 'items': {'type': 'dict', 'properties': {'timestamp': {'type': 'int', 'position': 0, 'description': 'When the comment was added.'}, 'user': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'comment': {'type': 'str', 'position': 0, 'description': "The comment's text."}}}}, 'encodedFlags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'DISABLED_MONITORING']}}}, 'description': 'Represents a configuration template, defining which code, configuration and default properties an instance should use.'}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation error'}}}
promote_all_template_instances = {'tags': ['configurationadmin'], 'summary': 'Promote all configuration instances for this template (INTERNAL)', 'description': '', 'operationId': 'promoteAllTemplateInstances', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'in': 'body', 'name': 'body', 'description': 'Promotion request', 'required': False, 'schema': {'type': 'object', 'properties': {'templateRevision': {'type': 'int', 'position': 0, 'description': 'The template revision to promote to. If not set, this will default to latest revision.', 'minimum': 0}, 'instances': {'type': 'list', 'position': 0, 'description': 'The instances to promote. Default is to promote all instances.', 'uniqueItems': True, 'items': {'type': 'int'}}}, 'description': 'Request to promote all instances of a template to a specific template revision'}}, {'name': 'idOrShortname', 'in': 'path', 'description': 'ID or shortname of template to promote', 'required': True, 'type': 'str'}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'properties': {'id': {'type': 'int', 'readOnly': True}, 'revision': {'type': 'int', 'position': 0, 'description': 'The revision of this instance', 'readOnly': True}, 'template': {'type': 'dict', 'properties': {'id': {'type': 'int', 'readOnly': True}, 'name': {'type': 'str', 'position': 0, 'description': 'The template name', 'readOnly': True}, 'shortName': {'type': 'str', 'position': 0, 'description': 'The shortname for this template', 'readOnly': True}, 'revision': {'type': 'int', 'position': 0, 'description': 'The revision index for the current template configuration. This is bumped on every change to the template.', 'readOnly': True}, 'mnemonic': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: The shortname for this template'}}, 'description': 'Informational reference model of a template'}, 'host': {'type': 'dict', 'properties': {'id': {'type': 'int', 'readOnly': True}, 'agentUserID': {'type': 'int', 'readOnly': True}, 'name': {'type': 'str', 'position': 0, 'description': 'The host name', 'readOnly': True}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int', 'position': 0, 'description': 'ID of the response object.'}, 'name': {'type': 'str', 'position': 0, 'description': 'Name of the customer.'}, 'shortName': {'type': 'str', 'position': 0, 'description': 'Shortname of the customer.'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int', 'position': 0, 'description': 'ID of the response object.'}, 'name': {'type': 'str', 'position': 0, 'description': 'Name of the domain.'}}, 'description': 'SPI DomainInfo'}}, 'description': 'SPI CustomerInfo'}}, 'description': 'Informational reference model for a host'}, 'parent': {'type': 'dict', 'properties': {'id': {'type': 'int', 'readOnly': True}, 'revision': {'type': 'int', 'position': 0, 'description': 'The revision of this instance', 'readOnly': True}, 'template': {'type': 'dict', 'properties': {'id': {'type': 'int', 'readOnly': True}, 'name': {'type': 'str', 'position': 0, 'description': 'The template name', 'readOnly': True}, 'shortName': {'type': 'str', 'position': 0, 'description': 'The shortname for this template', 'readOnly': True}, 'revision': {'type': 'int', 'position': 0, 'description': 'The revision index for the current template configuration. This is bumped on every change to the template.', 'readOnly': True}, 'mnemonic': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: The shortname for this template'}}, 'description': 'Informational reference model of a template'}, 'host': {'type': 'dict', 'properties': {'id': {'type': 'int', 'readOnly': True}, 'agentUserID': {'type': 'int', 'readOnly': True}, 'name': {'type': 'str', 'position': 0, 'description': 'The host name', 'readOnly': True}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int', 'position': 0, 'description': 'ID of the response object.'}, 'name': {'type': 'str', 'position': 0, 'description': 'Name of the customer.'}, 'shortName': {'type': 'str', 'position': 0, 'description': 'Shortname of the customer.'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int', 'position': 0, 'description': 'ID of the response object.'}, 'name': {'type': 'str', 'position': 0, 'description': 'Name of the domain.'}}, 'description': 'SPI DomainInfo'}}, 'description': 'SPI CustomerInfo'}}, 'description': 'Informational reference model for a host'}, 'parent': []}, 'description': 'Informational reference model of an instance'}}, 'description': 'Informational reference model of an instance'}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation error'}}}
search_templates = {'tags': ['configurationadmin'], 'summary': 'Search configuration templates (INTERNAL)', 'description': '', 'operationId': 'searchTemplates', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'in': 'body', 'name': 'body', 'required': False, 'schema': {'type': 'object', 'properties': {'limit': {'type': 'int', 'position': 0, 'description': 'Max number of results.'}, 'offset': {'type': 'int', 'position': 0, 'description': 'Skip the first (offset) objects. By default, return result from first object.'}, 'includeDeleted': {'type': 'bool', 'position': 0, 'description': 'Set to true to include deleted objects. By default, exclude deleted objects.'}, 'includeFlags': {'type': 'int', 'position': 0, 'description': 'Only include objects which have includeFlags set.'}, 'excludeFlags': {'type': 'int', 'position': 0, 'description': 'Exclude objects which have excludeFlags set.'}, 'subCriteria': {'type': 'list', 'position': 0, 'description': 'Set additional criterias which are applied using a logical OR.', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'limit': {'type': 'int', 'position': 0, 'description': 'Max number of results.'}, 'offset': {'type': 'int', 'position': 0, 'description': 'Skip the first (offset) objects. By default, return result from first object.'}, 'includeDeleted': {'type': 'bool', 'position': 0, 'description': 'Set to true to include deleted objects. By default, exclude deleted objects.'}, 'includeFlags': {'type': 'int', 'position': 0, 'description': 'Only include objects which have includeFlags set.'}, 'excludeFlags': {'type': 'int', 'position': 0, 'description': 'Exclude objects which have excludeFlags set.'}, 'subCriteria': {'type': 'list', 'position': 0, 'description': 'Set additional criterias which are applied using a logical OR.', 'uniqueItems': True, 'items': []}, 'exclude': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded.'}, 'required': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'codeProfile': {'type': 'list', 'position': 0, 'description': 'If true, filter on templates having any of these code profiles.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'keywords': {'type': 'list', 'position': 0, 'description': 'If true, filter on templates where name matches these keywords.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'template': {'type': 'list', 'position': 0, 'description': 'If set, filter on templates by ID or shortname.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'dependingOnID': {'type': 'list', 'position': 0, 'description': 'If set, filter on templates set to depend on any of the given template IDs.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'includeComments': {'type': 'bool', 'position': 0, 'description': 'If true, also include comments on output. (default false)', 'default': False}, 'includeConfiguration': {'type': 'bool', 'position': 0, 'description': 'If true, also include configuration on output. (default true)', 'default': True}, 'includeProperties': {'type': 'bool', 'position': 0, 'description': 'If true, also include properties on output. (default true)', 'default': True}, 'sortBy': {'type': 'list', 'position': 0, 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'items': {'type': 'str', 'enum': ['id', 'name', '-id', '-name']}}}}}, 'exclude': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded.'}, 'required': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'codeProfile': {'type': 'list', 'position': 0, 'description': 'If true, filter on templates having any of these code profiles.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'keywords': {'type': 'list', 'position': 0, 'description': 'If true, filter on templates where name matches these keywords.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'template': {'type': 'list', 'position': 0, 'description': 'If set, filter on templates by ID or shortname.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'dependingOnID': {'type': 'list', 'position': 0, 'description': 'If set, filter on templates set to depend on any of the given template IDs.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'includeComments': {'type': 'bool', 'position': 0, 'description': 'If true, also include comments on output. (default false)', 'default': False}, 'includeConfiguration': {'type': 'bool', 'position': 0, 'description': 'If true, also include configuration on output. (default true)', 'default': True}, 'includeProperties': {'type': 'bool', 'position': 0, 'description': 'If true, also include properties on output. (default true)', 'default': True}, 'sortBy': {'type': 'list', 'position': 0, 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'items': {'type': 'str', 'enum': ['id', 'name', '-id', '-name']}}}}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'required': ['codeProfile', 'name', 'shortName'], 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'name': {'type': 'str', 'position': 0, 'description': 'A unique name for this template'}, 'mnemonic': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: The shortname for this template'}, 'shortName': {'type': 'str', 'position': 0, 'description': 'The shortname for this template'}, 'configurationData': {'type': 'str', 'position': 0, 'description': 'The XML configuration for this template. May be null in search result if includeConfiguration is set to false, or if configurationResource is set.'}, 'configurationResource': {'type': 'str', 'position': 0, 'description': 'The configuration resource to load for this template. Is not set if template has explicit configuration data (XML)'}, 'properties': {'type': 'dict', 'position': 0, 'description': 'The properties set for this template. May be null in search result if includeProperties is set to false.', 'additionalProperties': {'type': 'string'}}, 'startupIndex': {'type': 'int', 'position': 0, 'description': 'The startup index for this template. When automatically starting instances, the startup ordering is determined by startupIndex.'}, 'revision': {'type': 'int', 'position': 0, 'description': 'The revision index for the current template configuration. This is bumped on every change to the template.'}, 'masterID': {'type': 'int', 'position': 0, 'description': 'If this object represents a configuration revision, this is the ID of the master instance configuration which is currently the latest revision.'}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was last updated.'}, 'codeProfile': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'deleted': {'type': 'boolean'}, 'finalized': {'type': 'boolean'}, 'name': {'type': 'str', 'position': 0, 'description': 'The name of this profile'}, 'created': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was created'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was last updated. Profiles which are finalized cannot be updated.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'artifacts': {'type': 'list', 'position': 0, 'description': 'The list of artifacts in this profile. May be null when searching for profiles, unless includeArtifacts is true', 'items': {'type': 'dict', 'properties': {'id': {'type': 'string'}, 'flags': {'type': 'int'}, 'groupID': {'type': 'str', 'position': 0, 'description': 'The MVN groupID'}, 'artifactID': {'type': 'str', 'position': 0, 'description': 'The MVN artifactID'}, 'version': {'type': 'str', 'position': 0, 'description': 'The MVN version'}, 'status': {'type': 'str', 'position': 0, 'description': 'The artifacts status. Can only be deleted if UNUSED.', 'enum': ['UNUSED', 'ACTIVE', 'DELETED']}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was last updated.'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'length': {'type': 'int', 'position': 0, 'description': 'The size of this artifact (in bytes).'}, 'data': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: This field is always null'}}, 'description': 'Describes a code artifact, typically a JAR file, which is available for download. The ID of the artifact is the SHA256-sum of the file.'}}}, 'description': 'A profile is a specific bundle of code artifacts. Non-finalized profiles cannot be used in templates, only in specific instances.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'information': {'type': 'str', 'position': 0, 'description': 'Informational text about this configuration (plain text, default sanitation).'}, 'dependsOn': {'type': 'dict', 'required': ['codeProfile', 'name', 'shortName'], 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'name': {'type': 'str', 'position': 0, 'description': 'A unique name for this template'}, 'mnemonic': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: The shortname for this template'}, 'shortName': {'type': 'str', 'position': 0, 'description': 'The shortname for this template'}, 'configurationData': {'type': 'str', 'position': 0, 'description': 'The XML configuration for this template. May be null in search result if includeConfiguration is set to false, or if configurationResource is set.'}, 'configurationResource': {'type': 'str', 'position': 0, 'description': 'The configuration resource to load for this template. Is not set if template has explicit configuration data (XML)'}, 'properties': {'type': 'dict', 'position': 0, 'description': 'The properties set for this template. May be null in search result if includeProperties is set to false.', 'additionalProperties': {'type': 'string'}}, 'startupIndex': {'type': 'int', 'position': 0, 'description': 'The startup index for this template. When automatically starting instances, the startup ordering is determined by startupIndex.'}, 'revision': {'type': 'int', 'position': 0, 'description': 'The revision index for the current template configuration. This is bumped on every change to the template.'}, 'masterID': {'type': 'int', 'position': 0, 'description': 'If this object represents a configuration revision, this is the ID of the master instance configuration which is currently the latest revision.'}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was last updated.'}, 'codeProfile': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'deleted': {'type': 'boolean'}, 'finalized': {'type': 'boolean'}, 'name': {'type': 'str', 'position': 0, 'description': 'The name of this profile'}, 'created': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was created'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was last updated. Profiles which are finalized cannot be updated.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'artifacts': {'type': 'list', 'position': 0, 'description': 'The list of artifacts in this profile. May be null when searching for profiles, unless includeArtifacts is true', 'items': {'type': 'dict', 'properties': {'id': {'type': 'string'}, 'flags': {'type': 'int'}, 'groupID': {'type': 'str', 'position': 0, 'description': 'The MVN groupID'}, 'artifactID': {'type': 'str', 'position': 0, 'description': 'The MVN artifactID'}, 'version': {'type': 'str', 'position': 0, 'description': 'The MVN version'}, 'status': {'type': 'str', 'position': 0, 'description': 'The artifacts status. Can only be deleted if UNUSED.', 'enum': ['UNUSED', 'ACTIVE', 'DELETED']}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was last updated.'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'length': {'type': 'int', 'position': 0, 'description': 'The size of this artifact (in bytes).'}, 'data': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: This field is always null'}}, 'description': 'Describes a code artifact, typically a JAR file, which is available for download. The ID of the artifact is the SHA256-sum of the file.'}}}, 'description': 'A profile is a specific bundle of code artifacts. Non-finalized profiles cannot be used in templates, only in specific instances.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'information': {'type': 'str', 'position': 0, 'description': 'Informational text about this configuration (plain text, default sanitation).'}, 'dependsOn': [], 'comments': {'type': 'list', 'position': 0, 'description': 'The comments configuration for this template. Is null in search result unless includeComments is set to true.', 'items': {'type': 'dict', 'properties': {'timestamp': {'type': 'int', 'position': 0, 'description': 'When the comment was added.'}, 'user': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'comment': {'type': 'str', 'position': 0, 'description': "The comment's text."}}}}, 'encodedFlags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'DISABLED_MONITORING']}}}, 'description': 'Represents a configuration template, defining which code, configuration and default properties an instance should use.'}, 'comments': {'type': 'list', 'position': 0, 'description': 'The comments configuration for this template. Is null in search result unless includeComments is set to true.', 'items': {'type': 'dict', 'properties': {'timestamp': {'type': 'int', 'position': 0, 'description': 'When the comment was added.'}, 'user': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'comment': {'type': 'str', 'position': 0, 'description': "The comment's text."}}}}, 'encodedFlags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'DISABLED_MONITORING']}}}, 'description': 'Represents a configuration template, defining which code, configuration and default properties an instance should use.'}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation error'}}}
template_revisions = {'tags': ['configurationadmin'], 'summary': 'List revisions of configuration template (INTERNAL)', 'description': '', 'operationId': 'templateRevisions', 'produces': ['application/json'], 'parameters': [{'name': 'idOrShortname', 'in': 'path', 'description': 'ID or shortname of template', 'required': True, 'type': 'str'}, {'name': 'limit', 'in': 'query', 'description': 'Max number of revisions to fetch', 'required': False, 'type': 'int', 'default': 25}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'required': ['codeProfile', 'name', 'shortName'], 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'name': {'type': 'str', 'position': 0, 'description': 'A unique name for this template'}, 'mnemonic': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: The shortname for this template'}, 'shortName': {'type': 'str', 'position': 0, 'description': 'The shortname for this template'}, 'configurationData': {'type': 'str', 'position': 0, 'description': 'The XML configuration for this template. May be null in search result if includeConfiguration is set to false, or if configurationResource is set.'}, 'configurationResource': {'type': 'str', 'position': 0, 'description': 'The configuration resource to load for this template. Is not set if template has explicit configuration data (XML)'}, 'properties': {'type': 'dict', 'position': 0, 'description': 'The properties set for this template. May be null in search result if includeProperties is set to false.', 'additionalProperties': {'type': 'string'}}, 'startupIndex': {'type': 'int', 'position': 0, 'description': 'The startup index for this template. When automatically starting instances, the startup ordering is determined by startupIndex.'}, 'revision': {'type': 'int', 'position': 0, 'description': 'The revision index for the current template configuration. This is bumped on every change to the template.'}, 'masterID': {'type': 'int', 'position': 0, 'description': 'If this object represents a configuration revision, this is the ID of the master instance configuration which is currently the latest revision.'}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was last updated.'}, 'codeProfile': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'deleted': {'type': 'boolean'}, 'finalized': {'type': 'boolean'}, 'name': {'type': 'str', 'position': 0, 'description': 'The name of this profile'}, 'created': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was created'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was last updated. Profiles which are finalized cannot be updated.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'artifacts': {'type': 'list', 'position': 0, 'description': 'The list of artifacts in this profile. May be null when searching for profiles, unless includeArtifacts is true', 'items': {'type': 'dict', 'properties': {'id': {'type': 'string'}, 'flags': {'type': 'int'}, 'groupID': {'type': 'str', 'position': 0, 'description': 'The MVN groupID'}, 'artifactID': {'type': 'str', 'position': 0, 'description': 'The MVN artifactID'}, 'version': {'type': 'str', 'position': 0, 'description': 'The MVN version'}, 'status': {'type': 'str', 'position': 0, 'description': 'The artifacts status. Can only be deleted if UNUSED.', 'enum': ['UNUSED', 'ACTIVE', 'DELETED']}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was last updated.'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'length': {'type': 'int', 'position': 0, 'description': 'The size of this artifact (in bytes).'}, 'data': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: This field is always null'}}, 'description': 'Describes a code artifact, typically a JAR file, which is available for download. The ID of the artifact is the SHA256-sum of the file.'}}}, 'description': 'A profile is a specific bundle of code artifacts. Non-finalized profiles cannot be used in templates, only in specific instances.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'information': {'type': 'str', 'position': 0, 'description': 'Informational text about this configuration (plain text, default sanitation).'}, 'dependsOn': {'type': 'dict', 'required': ['codeProfile', 'name', 'shortName'], 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'name': {'type': 'str', 'position': 0, 'description': 'A unique name for this template'}, 'mnemonic': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: The shortname for this template'}, 'shortName': {'type': 'str', 'position': 0, 'description': 'The shortname for this template'}, 'configurationData': {'type': 'str', 'position': 0, 'description': 'The XML configuration for this template. May be null in search result if includeConfiguration is set to false, or if configurationResource is set.'}, 'configurationResource': {'type': 'str', 'position': 0, 'description': 'The configuration resource to load for this template. Is not set if template has explicit configuration data (XML)'}, 'properties': {'type': 'dict', 'position': 0, 'description': 'The properties set for this template. May be null in search result if includeProperties is set to false.', 'additionalProperties': {'type': 'string'}}, 'startupIndex': {'type': 'int', 'position': 0, 'description': 'The startup index for this template. When automatically starting instances, the startup ordering is determined by startupIndex.'}, 'revision': {'type': 'int', 'position': 0, 'description': 'The revision index for the current template configuration. This is bumped on every change to the template.'}, 'masterID': {'type': 'int', 'position': 0, 'description': 'If this object represents a configuration revision, this is the ID of the master instance configuration which is currently the latest revision.'}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was last updated.'}, 'codeProfile': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'deleted': {'type': 'boolean'}, 'finalized': {'type': 'boolean'}, 'name': {'type': 'str', 'position': 0, 'description': 'The name of this profile'}, 'created': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was created'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was last updated. Profiles which are finalized cannot be updated.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'artifacts': {'type': 'list', 'position': 0, 'description': 'The list of artifacts in this profile. May be null when searching for profiles, unless includeArtifacts is true', 'items': {'type': 'dict', 'properties': {'id': {'type': 'string'}, 'flags': {'type': 'int'}, 'groupID': {'type': 'str', 'position': 0, 'description': 'The MVN groupID'}, 'artifactID': {'type': 'str', 'position': 0, 'description': 'The MVN artifactID'}, 'version': {'type': 'str', 'position': 0, 'description': 'The MVN version'}, 'status': {'type': 'str', 'position': 0, 'description': 'The artifacts status. Can only be deleted if UNUSED.', 'enum': ['UNUSED', 'ACTIVE', 'DELETED']}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was last updated.'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'length': {'type': 'int', 'position': 0, 'description': 'The size of this artifact (in bytes).'}, 'data': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: This field is always null'}}, 'description': 'Describes a code artifact, typically a JAR file, which is available for download. The ID of the artifact is the SHA256-sum of the file.'}}}, 'description': 'A profile is a specific bundle of code artifacts. Non-finalized profiles cannot be used in templates, only in specific instances.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'information': {'type': 'str', 'position': 0, 'description': 'Informational text about this configuration (plain text, default sanitation).'}, 'dependsOn': [], 'comments': {'type': 'list', 'position': 0, 'description': 'The comments configuration for this template. Is null in search result unless includeComments is set to true.', 'items': {'type': 'dict', 'properties': {'timestamp': {'type': 'int', 'position': 0, 'description': 'When the comment was added.'}, 'user': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'comment': {'type': 'str', 'position': 0, 'description': "The comment's text."}}}}, 'encodedFlags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'DISABLED_MONITORING']}}}, 'description': 'Represents a configuration template, defining which code, configuration and default properties an instance should use.'}, 'comments': {'type': 'list', 'position': 0, 'description': 'The comments configuration for this template. Is null in search result unless includeComments is set to true.', 'items': {'type': 'dict', 'properties': {'timestamp': {'type': 'int', 'position': 0, 'description': 'When the comment was added.'}, 'user': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'comment': {'type': 'str', 'position': 0, 'description': "The comment's text."}}}}, 'encodedFlags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'DISABLED_MONITORING']}}}, 'description': 'Represents a configuration template, defining which code, configuration and default properties an instance should use.'}}}}}}}
update_template = {'tags': ['configurationadmin'], 'summary': 'Update configuration template (INTERNAL)', 'description': '', 'operationId': 'updateTemplate', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'in': 'body', 'name': 'body', 'description': 'Update request', 'required': False, 'schema': {'type': 'object', 'properties': {'name': {'type': 'str', 'position': 0, 'description': 'If set, update the name of this template => [a-zA-Z0-9_:\\-\\.]*'}, 'mnemonic': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: If set, update the shortname of this template. Use shortName instead => [a-zA-Z0-9_:\\-\\.]*'}, 'shortName': {'type': 'str', 'position': 0, 'description': 'If set, update the shortname of this template => [a-zA-Z0-9_:\\-\\.]*'}, 'configuration': {'type': 'str', 'position': 0, 'description': 'If set, update the configuration of this template. Will clear configurationResource => format:xml'}, 'configurationResource': {'type': 'str', 'position': 0, 'description': 'Name of configuration resource (class name or classpath to Spring XML. Will clear explicit configuration. The resource must exist in the classpath of the code profile.'}, 'properties': {'type': 'dict', 'position': 0, 'description': 'If set, add these properties to the template. Properties with null value will be removed.', 'additionalProperties': {'type': 'string'}}, 'information': {'type': 'str', 'position': 0, 'description': 'If set, update the informational text of this template. Default sanitation. => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'dependsOnID': {'type': 'int', 'position': 0, 'description': 'If set, update the parent dependency to the template with this ID'}, 'codeProfile': {'type': 'str', 'position': 0, 'description': 'If set, update the code profile to use for this template. => [a-zA-Z0-9_:\\-\\.]*'}, 'startupIndex': {'type': 'int', 'position': 0, 'description': 'If set, change the startup order of this component', 'minimum': 0}}, 'description': 'Request to update a template'}}, {'name': 'idOrShortname', 'in': 'path', 'description': 'ID or shortname of template to update', 'required': True, 'type': 'str'}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'required': ['codeProfile', 'name', 'shortName'], 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'name': {'type': 'str', 'position': 0, 'description': 'A unique name for this template'}, 'mnemonic': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: The shortname for this template'}, 'shortName': {'type': 'str', 'position': 0, 'description': 'The shortname for this template'}, 'configurationData': {'type': 'str', 'position': 0, 'description': 'The XML configuration for this template. May be null in search result if includeConfiguration is set to false, or if configurationResource is set.'}, 'configurationResource': {'type': 'str', 'position': 0, 'description': 'The configuration resource to load for this template. Is not set if template has explicit configuration data (XML)'}, 'properties': {'type': 'dict', 'position': 0, 'description': 'The properties set for this template. May be null in search result if includeProperties is set to false.', 'additionalProperties': {'type': 'string'}}, 'startupIndex': {'type': 'int', 'position': 0, 'description': 'The startup index for this template. When automatically starting instances, the startup ordering is determined by startupIndex.'}, 'revision': {'type': 'int', 'position': 0, 'description': 'The revision index for the current template configuration. This is bumped on every change to the template.'}, 'masterID': {'type': 'int', 'position': 0, 'description': 'If this object represents a configuration revision, this is the ID of the master instance configuration which is currently the latest revision.'}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was last updated.'}, 'codeProfile': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'deleted': {'type': 'boolean'}, 'finalized': {'type': 'boolean'}, 'name': {'type': 'str', 'position': 0, 'description': 'The name of this profile'}, 'created': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was created'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was last updated. Profiles which are finalized cannot be updated.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'artifacts': {'type': 'list', 'position': 0, 'description': 'The list of artifacts in this profile. May be null when searching for profiles, unless includeArtifacts is true', 'items': {'type': 'dict', 'properties': {'id': {'type': 'string'}, 'flags': {'type': 'int'}, 'groupID': {'type': 'str', 'position': 0, 'description': 'The MVN groupID'}, 'artifactID': {'type': 'str', 'position': 0, 'description': 'The MVN artifactID'}, 'version': {'type': 'str', 'position': 0, 'description': 'The MVN version'}, 'status': {'type': 'str', 'position': 0, 'description': 'The artifacts status. Can only be deleted if UNUSED.', 'enum': ['UNUSED', 'ACTIVE', 'DELETED']}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was last updated.'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'length': {'type': 'int', 'position': 0, 'description': 'The size of this artifact (in bytes).'}, 'data': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: This field is always null'}}, 'description': 'Describes a code artifact, typically a JAR file, which is available for download. The ID of the artifact is the SHA256-sum of the file.'}}}, 'description': 'A profile is a specific bundle of code artifacts. Non-finalized profiles cannot be used in templates, only in specific instances.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'information': {'type': 'str', 'position': 0, 'description': 'Informational text about this configuration (plain text, default sanitation).'}, 'dependsOn': {'type': 'dict', 'required': ['codeProfile', 'name', 'shortName'], 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'name': {'type': 'str', 'position': 0, 'description': 'A unique name for this template'}, 'mnemonic': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: The shortname for this template'}, 'shortName': {'type': 'str', 'position': 0, 'description': 'The shortname for this template'}, 'configurationData': {'type': 'str', 'position': 0, 'description': 'The XML configuration for this template. May be null in search result if includeConfiguration is set to false, or if configurationResource is set.'}, 'configurationResource': {'type': 'str', 'position': 0, 'description': 'The configuration resource to load for this template. Is not set if template has explicit configuration data (XML)'}, 'properties': {'type': 'dict', 'position': 0, 'description': 'The properties set for this template. May be null in search result if includeProperties is set to false.', 'additionalProperties': {'type': 'string'}}, 'startupIndex': {'type': 'int', 'position': 0, 'description': 'The startup index for this template. When automatically starting instances, the startup ordering is determined by startupIndex.'}, 'revision': {'type': 'int', 'position': 0, 'description': 'The revision index for the current template configuration. This is bumped on every change to the template.'}, 'masterID': {'type': 'int', 'position': 0, 'description': 'If this object represents a configuration revision, this is the ID of the master instance configuration which is currently the latest revision.'}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was last updated.'}, 'codeProfile': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'deleted': {'type': 'boolean'}, 'finalized': {'type': 'boolean'}, 'name': {'type': 'str', 'position': 0, 'description': 'The name of this profile'}, 'created': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was created'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was last updated. Profiles which are finalized cannot be updated.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'artifacts': {'type': 'list', 'position': 0, 'description': 'The list of artifacts in this profile. May be null when searching for profiles, unless includeArtifacts is true', 'items': {'type': 'dict', 'properties': {'id': {'type': 'string'}, 'flags': {'type': 'int'}, 'groupID': {'type': 'str', 'position': 0, 'description': 'The MVN groupID'}, 'artifactID': {'type': 'str', 'position': 0, 'description': 'The MVN artifactID'}, 'version': {'type': 'str', 'position': 0, 'description': 'The MVN version'}, 'status': {'type': 'str', 'position': 0, 'description': 'The artifacts status. Can only be deleted if UNUSED.', 'enum': ['UNUSED', 'ACTIVE', 'DELETED']}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was last updated.'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'length': {'type': 'int', 'position': 0, 'description': 'The size of this artifact (in bytes).'}, 'data': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: This field is always null'}}, 'description': 'Describes a code artifact, typically a JAR file, which is available for download. The ID of the artifact is the SHA256-sum of the file.'}}}, 'description': 'A profile is a specific bundle of code artifacts. Non-finalized profiles cannot be used in templates, only in specific instances.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'information': {'type': 'str', 'position': 0, 'description': 'Informational text about this configuration (plain text, default sanitation).'}, 'dependsOn': [], 'comments': {'type': 'list', 'position': 0, 'description': 'The comments configuration for this template. Is null in search result unless includeComments is set to true.', 'items': {'type': 'dict', 'properties': {'timestamp': {'type': 'int', 'position': 0, 'description': 'When the comment was added.'}, 'user': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'comment': {'type': 'str', 'position': 0, 'description': "The comment's text."}}}}, 'encodedFlags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'DISABLED_MONITORING']}}}, 'description': 'Represents a configuration template, defining which code, configuration and default properties an instance should use.'}, 'comments': {'type': 'list', 'position': 0, 'description': 'The comments configuration for this template. Is null in search result unless includeComments is set to true.', 'items': {'type': 'dict', 'properties': {'timestamp': {'type': 'int', 'position': 0, 'description': 'When the comment was added.'}, 'user': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'comment': {'type': 'str', 'position': 0, 'description': "The comment's text."}}}}, 'encodedFlags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'DISABLED_MONITORING']}}}, 'description': 'Represents a configuration template, defining which code, configuration and default properties an instance should use.'}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation error'}}}
view_template = {'tags': ['configurationadmin'], 'summary': 'Fetch configuration template (INTERNAL)', 'description': '', 'operationId': 'viewTemplate', 'produces': ['application/json'], 'parameters': [{'name': 'idOrShortname', 'in': 'path', 'description': 'ID or shortname of template', 'required': True, 'type': 'str'}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'required': ['codeProfile', 'name', 'shortName'], 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'name': {'type': 'str', 'position': 0, 'description': 'A unique name for this template'}, 'mnemonic': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: The shortname for this template'}, 'shortName': {'type': 'str', 'position': 0, 'description': 'The shortname for this template'}, 'configurationData': {'type': 'str', 'position': 0, 'description': 'The XML configuration for this template. May be null in search result if includeConfiguration is set to false, or if configurationResource is set.'}, 'configurationResource': {'type': 'str', 'position': 0, 'description': 'The configuration resource to load for this template. Is not set if template has explicit configuration data (XML)'}, 'properties': {'type': 'dict', 'position': 0, 'description': 'The properties set for this template. May be null in search result if includeProperties is set to false.', 'additionalProperties': {'type': 'string'}}, 'startupIndex': {'type': 'int', 'position': 0, 'description': 'The startup index for this template. When automatically starting instances, the startup ordering is determined by startupIndex.'}, 'revision': {'type': 'int', 'position': 0, 'description': 'The revision index for the current template configuration. This is bumped on every change to the template.'}, 'masterID': {'type': 'int', 'position': 0, 'description': 'If this object represents a configuration revision, this is the ID of the master instance configuration which is currently the latest revision.'}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was last updated.'}, 'codeProfile': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'deleted': {'type': 'boolean'}, 'finalized': {'type': 'boolean'}, 'name': {'type': 'str', 'position': 0, 'description': 'The name of this profile'}, 'created': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was created'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was last updated. Profiles which are finalized cannot be updated.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'artifacts': {'type': 'list', 'position': 0, 'description': 'The list of artifacts in this profile. May be null when searching for profiles, unless includeArtifacts is true', 'items': {'type': 'dict', 'properties': {'id': {'type': 'string'}, 'flags': {'type': 'int'}, 'groupID': {'type': 'str', 'position': 0, 'description': 'The MVN groupID'}, 'artifactID': {'type': 'str', 'position': 0, 'description': 'The MVN artifactID'}, 'version': {'type': 'str', 'position': 0, 'description': 'The MVN version'}, 'status': {'type': 'str', 'position': 0, 'description': 'The artifacts status. Can only be deleted if UNUSED.', 'enum': ['UNUSED', 'ACTIVE', 'DELETED']}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was last updated.'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'length': {'type': 'int', 'position': 0, 'description': 'The size of this artifact (in bytes).'}, 'data': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: This field is always null'}}, 'description': 'Describes a code artifact, typically a JAR file, which is available for download. The ID of the artifact is the SHA256-sum of the file.'}}}, 'description': 'A profile is a specific bundle of code artifacts. Non-finalized profiles cannot be used in templates, only in specific instances.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'information': {'type': 'str', 'position': 0, 'description': 'Informational text about this configuration (plain text, default sanitation).'}, 'dependsOn': {'type': 'dict', 'required': ['codeProfile', 'name', 'shortName'], 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'name': {'type': 'str', 'position': 0, 'description': 'A unique name for this template'}, 'mnemonic': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: The shortname for this template'}, 'shortName': {'type': 'str', 'position': 0, 'description': 'The shortname for this template'}, 'configurationData': {'type': 'str', 'position': 0, 'description': 'The XML configuration for this template. May be null in search result if includeConfiguration is set to false, or if configurationResource is set.'}, 'configurationResource': {'type': 'str', 'position': 0, 'description': 'The configuration resource to load for this template. Is not set if template has explicit configuration data (XML)'}, 'properties': {'type': 'dict', 'position': 0, 'description': 'The properties set for this template. May be null in search result if includeProperties is set to false.', 'additionalProperties': {'type': 'string'}}, 'startupIndex': {'type': 'int', 'position': 0, 'description': 'The startup index for this template. When automatically starting instances, the startup ordering is determined by startupIndex.'}, 'revision': {'type': 'int', 'position': 0, 'description': 'The revision index for the current template configuration. This is bumped on every change to the template.'}, 'masterID': {'type': 'int', 'position': 0, 'description': 'If this object represents a configuration revision, this is the ID of the master instance configuration which is currently the latest revision.'}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this template was last updated.'}, 'codeProfile': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'flags': {'type': 'int'}, 'deleted': {'type': 'boolean'}, 'finalized': {'type': 'boolean'}, 'name': {'type': 'str', 'position': 0, 'description': 'The name of this profile'}, 'created': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was created'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this profile was last updated. Profiles which are finalized cannot be updated.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'artifacts': {'type': 'list', 'position': 0, 'description': 'The list of artifacts in this profile. May be null when searching for profiles, unless includeArtifacts is true', 'items': {'type': 'dict', 'properties': {'id': {'type': 'string'}, 'flags': {'type': 'int'}, 'groupID': {'type': 'str', 'position': 0, 'description': 'The MVN groupID'}, 'artifactID': {'type': 'str', 'position': 0, 'description': 'The MVN artifactID'}, 'version': {'type': 'str', 'position': 0, 'description': 'The MVN version'}, 'status': {'type': 'str', 'position': 0, 'description': 'The artifacts status. Can only be deleted if UNUSED.', 'enum': ['UNUSED', 'ACTIVE', 'DELETED']}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was created.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the artifact was last updated.'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'length': {'type': 'int', 'position': 0, 'description': 'The size of this artifact (in bytes).'}, 'data': {'type': 'str', 'position': 0, 'description': 'DEPRECATED: This field is always null'}}, 'description': 'Describes a code artifact, typically a JAR file, which is available for download. The ID of the artifact is the SHA256-sum of the file.'}}}, 'description': 'A profile is a specific bundle of code artifacts. Non-finalized profiles cannot be used in templates, only in specific instances.'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'information': {'type': 'str', 'position': 0, 'description': 'Informational text about this configuration (plain text, default sanitation).'}, 'dependsOn': [], 'comments': {'type': 'list', 'position': 0, 'description': 'The comments configuration for this template. Is null in search result unless includeComments is set to true.', 'items': {'type': 'dict', 'properties': {'timestamp': {'type': 'int', 'position': 0, 'description': 'When the comment was added.'}, 'user': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'comment': {'type': 'str', 'position': 0, 'description': "The comment's text."}}}}, 'encodedFlags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'DISABLED_MONITORING']}}}, 'description': 'Represents a configuration template, defining which code, configuration and default properties an instance should use.'}, 'comments': {'type': 'list', 'position': 0, 'description': 'The comments configuration for this template. Is null in search result unless includeComments is set to true.', 'items': {'type': 'dict', 'properties': {'timestamp': {'type': 'int', 'position': 0, 'description': 'When the comment was added.'}, 'user': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'comment': {'type': 'str', 'position': 0, 'description': "The comment's text."}}}}, 'encodedFlags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'DISABLED_MONITORING']}}}, 'description': 'Represents a configuration template, defining which code, configuration and default properties an instance should use.'}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}}}
#: "add_comment_2" is an alias for "add_template_comment"
add_comment_2 = add_template_comment
#: "create_4" is an alias for "create_template"
create_4 = create_template
#: "delete_3" is an alias for "delete_template"
delete_3 = delete_template
#: "duplicate_3" is an alias for "duplicate_template"
duplicate_3 = duplicate_template
#: "list_4" is an alias for "list_templates"
list_4 = list_templates
#: "search_4" is an alias for "search_templates"
search_4 = search_templates
#: "revisions_1" is an alias for "template_revisions"
revisions_1 = template_revisions
#: "update_3" is an alias for "update_template"
update_3 = update_template
#: "view_2" is an alias for "view_template"
view_2 = view_template