"""Autogenerated API schema"""
from argus_api import session


lookup_ip = {'tags': ['development'], 'summary': 'Lookup IP range (DEV)', 'description': '', 'operationId': 'lookupIP', 'produces': ['application/json'], 'parameters': [{'name': 'address', 'in': 'path', 'description': 'IP-address to search for', 'required': True, 'type': 'str'}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'range': {'type': 'dict', 'properties': {'fromAddress': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'public': {'type': 'boolean'}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}, 'toAddress': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'public': {'type': 'boolean'}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}}}, 'countryCode': {'type': 'str', 'position': 0, 'description': 'The two-letter code of the country where this IP-range is located'}, 'locationID': {'type': 'int', 'position': 0, 'description': 'The location ID associated with this IP-range'}, 'lastModified': {'type': 'int', 'position': 0, 'description': 'The timestamp when this IP-range was last modified'}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['deleted']}}, 'latitude': {'type': 'float', 'position': 0, 'description': 'Geographic latitude of the spot where this IP-range is located (0.0 if not set)'}, 'longitude': {'type': 'float', 'position': 0, 'description': 'Geographic longitude of the spot where this IP-range is located (0.0 if not set)'}}, 'description': 'Combines IP-address range (from- and to-address) with country and location data'}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation failed'}}}