"""Autogenerated API schema"""
from argus_api import session


add_address_overrides = {'tags': ['reputation/v1'], 'summary': 'Add reputation IP override (INTERNAL)', 'description': '', 'operationId': 'addAddressOverrides', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'in': 'body', 'name': 'body', 'description': 'Override add request', 'required': False, 'schema': {'type': 'object', 'properties': {'listName': {'type': 'str', 'position': 0, 'description': "The globally unique name of the override list to which we're adding the address override entries."}, 'listID': {'type': 'int', 'position': 0, 'description': "The ID of the override list to which we're adding the address override entries."}, 'clear': {'type': 'bool', 'position': 0, 'description': 'Whether to remove all current override entries in the override list. (default false)', 'default': False}, 'overrides': {'type': 'list', 'position': 0, 'description': 'The address override entries to add.', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'ipRange': {'type': 'string'}, 'value': {'type': 'float', 'position': 0, 'description': 'The value for this override entry. Ranges from 0 to 1.0'}, 'reason': {'type': 'str', 'position': 0, 'description': 'The reason this override entry was created.'}, 'cutoff': {'type': 'int', 'position': 0, 'description': 'When this override entry expires.'}}, 'description': 'An IP address override entry.'}}}, 'description': 'Request to add an address override entry to an override list.'}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'expired': {'type': 'boolean'}, 'deleted': {'type': 'boolean'}, 'flags': {'type': 'int', 'position': 0, 'description': 'Flags for the override entry'}, 'listName': {'type': 'str', 'position': 0, 'description': 'The name of the override list to which this override entry belongs.'}, 'data': {'type': 'dict', 'properties': {'value': {'type': 'float', 'position': 0, 'description': "The override entry's value."}, 'entryTime': {'type': 'int', 'position': 0, 'description': 'When the override entry was created.'}, 'reason': {'type': 'str', 'position': 0, 'description': 'The reason this override was created.'}, 'cutoff': {'type': 'int', 'position': 0, 'description': 'Time until which the override entry is valid.'}, 'userID': {'type': 'int', 'position': 0, 'description': 'DEPRECATED: Deprecated, use the user field.'}, 'user': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}}, 'description': 'Common data for an override entry.'}, 'defaultValue': {'type': 'bool', 'position': 0, 'description': 'Whether this override entry may be used as a default value'}, 'range': {'type': 'dict', 'properties': {'fromAddress': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'public': {'type': 'boolean'}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}, 'toAddress': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'public': {'type': 'boolean'}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'When the override entry was last updated.', 'readOnly': True}}, 'description': 'An IP address entry in an Override List.'}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation error'}}}
add_domain_override = {'tags': ['reputation/v1'], 'summary': 'Add reputation domain override (INTERNAL)', 'description': '', 'operationId': 'addDomainOverride', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'in': 'body', 'name': 'body', 'description': 'Override add request', 'required': False, 'schema': {'type': 'object', 'properties': {'listID': {'type': 'int', 'position': 0, 'description': "The ID of the override list to which we're adding the domain override entries."}, 'listName': {'type': 'str', 'position': 0, 'description': "The globally unique name of the override list to which we're adding the domain override entries."}, 'clear': {'type': 'bool', 'position': 0, 'description': 'Whether to remove all current override entries in the override list. (default false)', 'default': False}, 'overrides': {'type': 'list', 'position': 0, 'description': 'The domain override entries to add.', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'domainPattern': {'type': 'string'}, 'value': {'type': 'float', 'position': 0, 'description': 'The value for this override entry. Ranges from 0 to 1.0'}, 'reason': {'type': 'str', 'position': 0, 'description': 'The reason this override entry was created.'}, 'cutoff': {'type': 'int', 'position': 0, 'description': 'When this override entry expires.'}}, 'description': 'A domain name override entry.'}}}, 'description': 'Request to add a domain name override entry to an override list.'}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'domainPattern': {'type': 'string'}, 'wildcardMatch': {'type': 'boolean'}, 'publicPrefixMatch': {'type': 'boolean'}, 'expired': {'type': 'boolean'}, 'deleted': {'type': 'boolean'}, 'flags': {'type': 'int', 'position': 0, 'description': 'Flags for the override entry'}, 'listName': {'type': 'str', 'position': 0, 'description': 'The name of the override list to which this override entry belongs.'}, 'data': {'type': 'dict', 'properties': {'value': {'type': 'float', 'position': 0, 'description': "The override entry's value."}, 'entryTime': {'type': 'int', 'position': 0, 'description': 'When the override entry was created.'}, 'reason': {'type': 'str', 'position': 0, 'description': 'The reason this override was created.'}, 'cutoff': {'type': 'int', 'position': 0, 'description': 'Time until which the override entry is valid.'}, 'userID': {'type': 'int', 'position': 0, 'description': 'DEPRECATED: Deprecated, use the user field.'}, 'user': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}}, 'description': 'Common data for an override entry.'}, 'defaultValue': {'type': 'bool', 'position': 0, 'description': 'Whether this override entry may be used as a default value'}, 'domainPatternBase': {'type': 'str', 'position': 0, 'description': "The domain name's pattern base"}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'When the override entry was last updated.', 'readOnly': True}}, 'description': 'A Domain Name entry in an override list.'}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation error'}}}
add_override_list = {'tags': ['reputation/v1'], 'summary': 'Add reputation override list (INTERNAL)', 'description': '', 'operationId': 'addOverrideList', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'in': 'body', 'name': 'body', 'description': 'Override add request', 'required': False, 'schema': {'type': 'object', 'required': ['description', 'name'], 'properties': {'name': {'type': 'str', 'position': 0, 'description': 'Unique Override list name => [a-zA-Z0-9_:\\-\\.]*'}, 'description': {'type': 'str', 'position': 0, 'description': 'Override list description => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'useForReputationCalc': {'type': 'bool', 'position': 0, 'description': 'If true, enable use of the overrides in this list when calculating reputation values. (default false)', 'default': False}, 'useForInputFiltering': {'type': 'bool', 'position': 0, 'description': 'If true, enable use of the overrides in this list for observation input filtering. (default false)', 'default': False}, 'useForDefaultValues': {'type': 'bool', 'position': 0, 'description': 'If true, enable use of the overrides in this list as default values. (default false)', 'default': False}}, 'description': 'Request to create a new Override List.'}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'defaultValues': {'type': 'boolean'}, 'lastModified': {'type': 'int', 'position': 0, 'description': 'The last time the Override List was updated.'}, 'name': {'type': 'str', 'position': 0, 'description': "The Override List's name. As it is globally unique it can be used to retrieve the Override List's metadata."}, 'description': {'type': 'str', 'position': 0, 'description': "The Override List's description."}}, 'description': 'A collection of override entries.'}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation error'}}}
delete_address_override = {'tags': ['reputation/v1'], 'summary': 'Delete reputation IP override (INTERNAL)', 'description': '', 'operationId': 'deleteAddressOverride', 'produces': ['application/json'], 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of override entry to remove', 'required': True, 'type': 'int', 'pattern': '[0-9]+'}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'expired': {'type': 'boolean'}, 'deleted': {'type': 'boolean'}, 'flags': {'type': 'int', 'position': 0, 'description': 'Flags for the override entry'}, 'listName': {'type': 'str', 'position': 0, 'description': 'The name of the override list to which this override entry belongs.'}, 'data': {'type': 'dict', 'properties': {'value': {'type': 'float', 'position': 0, 'description': "The override entry's value."}, 'entryTime': {'type': 'int', 'position': 0, 'description': 'When the override entry was created.'}, 'reason': {'type': 'str', 'position': 0, 'description': 'The reason this override was created.'}, 'cutoff': {'type': 'int', 'position': 0, 'description': 'Time until which the override entry is valid.'}, 'userID': {'type': 'int', 'position': 0, 'description': 'DEPRECATED: Deprecated, use the user field.'}, 'user': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}}, 'description': 'Common data for an override entry.'}, 'defaultValue': {'type': 'bool', 'position': 0, 'description': 'Whether this override entry may be used as a default value'}, 'range': {'type': 'dict', 'properties': {'fromAddress': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'public': {'type': 'boolean'}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}, 'toAddress': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'public': {'type': 'boolean'}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'When the override entry was last updated.', 'readOnly': True}}, 'description': 'An IP address entry in an Override List.'}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation error'}}}
delete_address_overrides = {'tags': ['reputation/v1'], 'summary': 'Bulk delete reputation IP overrides (INTERNAL)', 'description': '', 'operationId': 'deleteAddressOverrides', 'produces': ['application/json'], 'parameters': [{'name': 'id', 'in': 'query', 'description': 'IDs of IP overrides', 'required': False, 'type': 'list', 'items': {'type': 'int'}, 'collectionFormat': 'multi', 'maxItems': 2147483647, 'minItems': 1}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'expired': {'type': 'boolean'}, 'deleted': {'type': 'boolean'}, 'flags': {'type': 'int', 'position': 0, 'description': 'Flags for the override entry'}, 'listName': {'type': 'str', 'position': 0, 'description': 'The name of the override list to which this override entry belongs.'}, 'data': {'type': 'dict', 'properties': {'value': {'type': 'float', 'position': 0, 'description': "The override entry's value."}, 'entryTime': {'type': 'int', 'position': 0, 'description': 'When the override entry was created.'}, 'reason': {'type': 'str', 'position': 0, 'description': 'The reason this override was created.'}, 'cutoff': {'type': 'int', 'position': 0, 'description': 'Time until which the override entry is valid.'}, 'userID': {'type': 'int', 'position': 0, 'description': 'DEPRECATED: Deprecated, use the user field.'}, 'user': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}}, 'description': 'Common data for an override entry.'}, 'defaultValue': {'type': 'bool', 'position': 0, 'description': 'Whether this override entry may be used as a default value'}, 'range': {'type': 'dict', 'properties': {'fromAddress': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'public': {'type': 'boolean'}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}, 'toAddress': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'public': {'type': 'boolean'}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'When the override entry was last updated.', 'readOnly': True}}, 'description': 'An IP address entry in an Override List.'}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation error'}}}
delete_domain_override = {'tags': ['reputation/v1'], 'summary': 'Delete reputation domain override (INTERNAL)', 'description': '', 'operationId': 'deleteDomainOverride', 'produces': ['application/json'], 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of override entry to remove', 'required': True, 'type': 'int', 'pattern': '[0-9]+'}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'domainPattern': {'type': 'string'}, 'wildcardMatch': {'type': 'boolean'}, 'publicPrefixMatch': {'type': 'boolean'}, 'expired': {'type': 'boolean'}, 'deleted': {'type': 'boolean'}, 'flags': {'type': 'int', 'position': 0, 'description': 'Flags for the override entry'}, 'listName': {'type': 'str', 'position': 0, 'description': 'The name of the override list to which this override entry belongs.'}, 'data': {'type': 'dict', 'properties': {'value': {'type': 'float', 'position': 0, 'description': "The override entry's value."}, 'entryTime': {'type': 'int', 'position': 0, 'description': 'When the override entry was created.'}, 'reason': {'type': 'str', 'position': 0, 'description': 'The reason this override was created.'}, 'cutoff': {'type': 'int', 'position': 0, 'description': 'Time until which the override entry is valid.'}, 'userID': {'type': 'int', 'position': 0, 'description': 'DEPRECATED: Deprecated, use the user field.'}, 'user': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}}, 'description': 'Common data for an override entry.'}, 'defaultValue': {'type': 'bool', 'position': 0, 'description': 'Whether this override entry may be used as a default value'}, 'domainPatternBase': {'type': 'str', 'position': 0, 'description': "The domain name's pattern base"}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'When the override entry was last updated.', 'readOnly': True}}, 'description': 'A Domain Name entry in an override list.'}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation error'}}}
delete_domain_overrides = {'tags': ['reputation/v1'], 'summary': 'Bulk delete reputation domain overrides (INTERNAL)', 'description': '', 'operationId': 'deleteDomainOverrides', 'produces': ['application/json'], 'parameters': [{'name': 'id', 'in': 'query', 'description': 'IDs of reputation overrides', 'required': False, 'type': 'list', 'items': {'type': 'int'}, 'collectionFormat': 'multi', 'maxItems': 2147483647, 'minItems': 1}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'domainPattern': {'type': 'string'}, 'wildcardMatch': {'type': 'boolean'}, 'publicPrefixMatch': {'type': 'boolean'}, 'expired': {'type': 'boolean'}, 'deleted': {'type': 'boolean'}, 'flags': {'type': 'int', 'position': 0, 'description': 'Flags for the override entry'}, 'listName': {'type': 'str', 'position': 0, 'description': 'The name of the override list to which this override entry belongs.'}, 'data': {'type': 'dict', 'properties': {'value': {'type': 'float', 'position': 0, 'description': "The override entry's value."}, 'entryTime': {'type': 'int', 'position': 0, 'description': 'When the override entry was created.'}, 'reason': {'type': 'str', 'position': 0, 'description': 'The reason this override was created.'}, 'cutoff': {'type': 'int', 'position': 0, 'description': 'Time until which the override entry is valid.'}, 'userID': {'type': 'int', 'position': 0, 'description': 'DEPRECATED: Deprecated, use the user field.'}, 'user': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}}, 'description': 'Common data for an override entry.'}, 'defaultValue': {'type': 'bool', 'position': 0, 'description': 'Whether this override entry may be used as a default value'}, 'domainPatternBase': {'type': 'str', 'position': 0, 'description': "The domain name's pattern base"}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'When the override entry was last updated.', 'readOnly': True}}, 'description': 'A Domain Name entry in an override list.'}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation error'}}}
delete_override_list = {'tags': ['reputation/v1'], 'summary': 'Delete reputation override list (INTERNAL)', 'description': '', 'operationId': 'deleteOverrideList', 'produces': ['application/json'], 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of override list to remove', 'required': True, 'type': 'int', 'minimum': 1, 'pattern': '[0-9]+'}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'defaultValues': {'type': 'boolean'}, 'lastModified': {'type': 'int', 'position': 0, 'description': 'The last time the Override List was updated.'}, 'name': {'type': 'str', 'position': 0, 'description': "The Override List's name. As it is globally unique it can be used to retrieve the Override List's metadata."}, 'description': {'type': 'str', 'position': 0, 'description': "The Override List's description."}}, 'description': 'A collection of override entries.'}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation error'}}}
find_address_overrides = {'tags': ['reputation/v1'], 'summary': 'Search IP overrides (INTERNAL)', 'description': '', 'operationId': 'findAddressOverrides', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'in': 'body', 'name': 'body', 'description': 'Search criteria', 'required': False, 'schema': {'type': 'object', 'properties': {'ranges': {'type': 'list', 'items': {'type': 'string'}}, 'limit': {'type': 'int', 'position': 0, 'description': 'Max number of results.'}, 'offset': {'type': 'int', 'position': 0, 'description': 'Skip the first (offset) objects. By default, return result from first object.'}, 'includeDeleted': {'type': 'bool', 'position': 0, 'description': 'Set to true to include deleted objects. By default, exclude deleted objects.'}, 'includeFlags': {'type': 'int', 'position': 0, 'description': 'Only include objects which have includeFlags set.'}, 'excludeFlags': {'type': 'int', 'position': 0, 'description': 'Exclude objects which have excludeFlags set.'}, 'subCriteria': {'type': 'list', 'position': 0, 'description': 'Set additional criterias which are applied using a logical OR.', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'ranges': {'type': 'list', 'items': {'type': 'string'}}, 'limit': {'type': 'int', 'position': 0, 'description': 'Max number of results.'}, 'offset': {'type': 'int', 'position': 0, 'description': 'Skip the first (offset) objects. By default, return result from first object.'}, 'includeDeleted': {'type': 'bool', 'position': 0, 'description': 'Set to true to include deleted objects. By default, exclude deleted objects.'}, 'includeFlags': {'type': 'int', 'position': 0, 'description': 'Only include objects which have includeFlags set.'}, 'excludeFlags': {'type': 'int', 'position': 0, 'description': 'Exclude objects which have excludeFlags set.'}, 'subCriteria': {'type': 'list', 'position': 0, 'description': 'Set additional criterias which are applied using a logical OR.', 'uniqueItems': True, 'items': []}, 'exclude': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded.'}, 'required': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'listID': {'type': 'list', 'position': 0, 'description': "Collection of override lists' IDs", 'items': {'type': 'int'}}, 'listName': {'type': 'list', 'position': 0, 'description': "Collection of override lists' names", 'items': {'type': 'string'}}, 'includedListFlags': {'type': 'int', 'position': 0, 'description': 'Include records with flags in override list'}, 'excludedListFlags': {'type': 'int', 'position': 0, 'description': 'Exclude records with flags in override list'}, 'includeExpired': {'type': 'bool', 'position': 0, 'description': 'Whether include expired overrides, default not include expired overrides'}, 'startTimestamp': {'type': 'int', 'position': 0, 'description': 'Records after this timestamp against fields defined by timeFieldStrategy'}, 'endTimestamp': {'type': 'int', 'position': 0, 'description': 'Records before this timestamp against fields defined by timeFieldStrategy'}, 'timeFieldStrategy': {'type': 'list', 'position': 0, 'description': 'TimeFieldStrategy to define which timestamp field(s) to match, default lastUpdatedTimestamp', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['lastUpdatedTimestamp', 'cutoff', 'all']}}, 'minValue': {'type': 'float', 'position': 0, 'description': 'Lower bound for override value range [0,1]'}, 'maxValue': {'type': 'float', 'position': 0, 'description': 'Upper bound for override data value range [0,1]'}, 'keywords': {'type': 'list', 'position': 0, 'description': 'Set of keywords to match selected fields, depends on KeywordMatchStrategy', 'uniqueItems': True, 'items': {'type': 'string'}}, 'keywordMatchStrategy': {'type': 'str', 'position': 0, 'description': 'Define whether all/any keywords have to be matched with selected fields', 'enum': ['all', 'any']}, 'timeMatchStrategy': {'type': 'str', 'position': 0, 'description': 'Defines how strict to match against different timestamps (all/any) using start and end timestamp (default any)', 'enum': ['all', 'any']}, 'keywordFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Define which field(s) to be matched against keywords', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['reason', 'range', 'all']}}, 'sortBy': {'type': 'list', 'position': 0, 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'items': {'type': 'str', 'enum': ['id', 'lastModified', 'range', '-id', '-lastModified', '-range']}}}, 'description': 'Search criteria for overrides for matching IP addresses'}}, 'exclude': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded.'}, 'required': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'listID': {'type': 'list', 'position': 0, 'description': "Collection of override lists' IDs", 'items': {'type': 'int'}}, 'listName': {'type': 'list', 'position': 0, 'description': "Collection of override lists' names", 'items': {'type': 'string'}}, 'includedListFlags': {'type': 'int', 'position': 0, 'description': 'Include records with flags in override list'}, 'excludedListFlags': {'type': 'int', 'position': 0, 'description': 'Exclude records with flags in override list'}, 'includeExpired': {'type': 'bool', 'position': 0, 'description': 'Whether include expired overrides, default not include expired overrides'}, 'startTimestamp': {'type': 'int', 'position': 0, 'description': 'Records after this timestamp against fields defined by timeFieldStrategy'}, 'endTimestamp': {'type': 'int', 'position': 0, 'description': 'Records before this timestamp against fields defined by timeFieldStrategy'}, 'timeFieldStrategy': {'type': 'list', 'position': 0, 'description': 'TimeFieldStrategy to define which timestamp field(s) to match, default lastUpdatedTimestamp', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['lastUpdatedTimestamp', 'cutoff', 'all']}}, 'minValue': {'type': 'float', 'position': 0, 'description': 'Lower bound for override value range [0,1]'}, 'maxValue': {'type': 'float', 'position': 0, 'description': 'Upper bound for override data value range [0,1]'}, 'keywords': {'type': 'list', 'position': 0, 'description': 'Set of keywords to match selected fields, depends on KeywordMatchStrategy', 'uniqueItems': True, 'items': {'type': 'string'}}, 'keywordMatchStrategy': {'type': 'str', 'position': 0, 'description': 'Define whether all/any keywords have to be matched with selected fields', 'enum': ['all', 'any']}, 'timeMatchStrategy': {'type': 'str', 'position': 0, 'description': 'Defines how strict to match against different timestamps (all/any) using start and end timestamp (default any)', 'enum': ['all', 'any']}, 'keywordFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Define which field(s) to be matched against keywords', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['reason', 'range', 'all']}}, 'sortBy': {'type': 'list', 'position': 0, 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'items': {'type': 'str', 'enum': ['id', 'lastModified', 'range', '-id', '-lastModified', '-range']}}}, 'description': 'Search criteria for overrides for matching IP addresses'}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'expired': {'type': 'boolean'}, 'deleted': {'type': 'boolean'}, 'flags': {'type': 'int', 'position': 0, 'description': 'Flags for the override entry'}, 'listName': {'type': 'str', 'position': 0, 'description': 'The name of the override list to which this override entry belongs.'}, 'data': {'type': 'dict', 'properties': {'value': {'type': 'float', 'position': 0, 'description': "The override entry's value."}, 'entryTime': {'type': 'int', 'position': 0, 'description': 'When the override entry was created.'}, 'reason': {'type': 'str', 'position': 0, 'description': 'The reason this override was created.'}, 'cutoff': {'type': 'int', 'position': 0, 'description': 'Time until which the override entry is valid.'}, 'userID': {'type': 'int', 'position': 0, 'description': 'DEPRECATED: Deprecated, use the user field.'}, 'user': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}}, 'description': 'Common data for an override entry.'}, 'defaultValue': {'type': 'bool', 'position': 0, 'description': 'Whether this override entry may be used as a default value'}, 'range': {'type': 'dict', 'properties': {'fromAddress': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'public': {'type': 'boolean'}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}, 'toAddress': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'public': {'type': 'boolean'}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'When the override entry was last updated.', 'readOnly': True}}, 'description': 'An IP address entry in an Override List.'}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation error'}}}
find_domain_overrides = {'tags': ['reputation/v1'], 'summary': 'Search domain overrides (INTERNAL)', 'description': '', 'operationId': 'findDomainOverrides', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'in': 'body', 'name': 'body', 'description': 'Search criteria', 'required': False, 'schema': {'type': 'object', 'properties': {'limit': {'type': 'int', 'position': 0, 'description': 'Max number of results.'}, 'offset': {'type': 'int', 'position': 0, 'description': 'Skip the first (offset) objects. By default, return result from first object.'}, 'includeDeleted': {'type': 'bool', 'position': 0, 'description': 'Set to true to include deleted objects. By default, exclude deleted objects.'}, 'includeFlags': {'type': 'int', 'position': 0, 'description': 'Only include objects which have includeFlags set.'}, 'excludeFlags': {'type': 'int', 'position': 0, 'description': 'Exclude objects which have excludeFlags set.'}, 'subCriteria': {'type': 'list', 'position': 0, 'description': 'Set additional criterias which are applied using a logical OR.', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'limit': {'type': 'int', 'position': 0, 'description': 'Max number of results.'}, 'offset': {'type': 'int', 'position': 0, 'description': 'Skip the first (offset) objects. By default, return result from first object.'}, 'includeDeleted': {'type': 'bool', 'position': 0, 'description': 'Set to true to include deleted objects. By default, exclude deleted objects.'}, 'includeFlags': {'type': 'int', 'position': 0, 'description': 'Only include objects which have includeFlags set.'}, 'excludeFlags': {'type': 'int', 'position': 0, 'description': 'Exclude objects which have excludeFlags set.'}, 'subCriteria': {'type': 'list', 'position': 0, 'description': 'Set additional criterias which are applied using a logical OR.', 'uniqueItems': True, 'items': []}, 'exclude': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded.'}, 'required': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'listID': {'type': 'list', 'position': 0, 'description': "Collection of override lists' IDs", 'items': {'type': 'int'}}, 'listName': {'type': 'list', 'position': 0, 'description': "Collection of override lists' names", 'items': {'type': 'string'}}, 'includedListFlags': {'type': 'int', 'position': 0, 'description': 'Include records with flags in override list'}, 'excludedListFlags': {'type': 'int', 'position': 0, 'description': 'Exclude records with flags in override list'}, 'includeExpired': {'type': 'bool', 'position': 0, 'description': 'Whether include expired overrides, default not include expired overrides'}, 'startTimestamp': {'type': 'int', 'position': 0, 'description': 'Records after this timestamp against fields defined by timeFieldStrategy'}, 'endTimestamp': {'type': 'int', 'position': 0, 'description': 'Records before this timestamp against fields defined by timeFieldStrategy'}, 'timeFieldStrategy': {'type': 'list', 'position': 0, 'description': 'TimeFieldStrategy to define which timestamp field(s) to match, default lastUpdatedTimestamp', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['lastUpdatedTimestamp', 'cutoff', 'all']}}, 'minValue': {'type': 'float', 'position': 0, 'description': 'Lower bound for override value range [0,1]'}, 'maxValue': {'type': 'float', 'position': 0, 'description': 'Upper bound for override data value range [0,1]'}, 'keywords': {'type': 'list', 'position': 0, 'description': 'Set of keywords to match selected fields, depends on KeywordMatchStrategy', 'uniqueItems': True, 'items': {'type': 'string'}}, 'keywordMatchStrategy': {'type': 'str', 'position': 0, 'description': 'Define whether all/any keywords have to be matched with selected fields', 'enum': ['all', 'any']}, 'timeMatchStrategy': {'type': 'str', 'position': 0, 'description': 'Defines how strict to match against different timestamps (all/any) using start and end timestamp (default any)', 'enum': ['all', 'any']}, 'domainPatternBases': {'type': 'list', 'position': 0, 'description': 'Collection of domain pattern bases', 'items': {'type': 'string'}}, 'keywordFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Define which field(s) to be matched against keywords', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['reason', 'domainPattern', 'all']}}, 'sortBy': {'type': 'list', 'position': 0, 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'items': {'type': 'str', 'enum': ['id', 'lastModified', 'domainPattern', '-id', '-lastModified', '-domainPattern']}}}, 'description': 'Search criteria for overrides for matching domains'}}, 'exclude': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded.'}, 'required': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'listID': {'type': 'list', 'position': 0, 'description': "Collection of override lists' IDs", 'items': {'type': 'int'}}, 'listName': {'type': 'list', 'position': 0, 'description': "Collection of override lists' names", 'items': {'type': 'string'}}, 'includedListFlags': {'type': 'int', 'position': 0, 'description': 'Include records with flags in override list'}, 'excludedListFlags': {'type': 'int', 'position': 0, 'description': 'Exclude records with flags in override list'}, 'includeExpired': {'type': 'bool', 'position': 0, 'description': 'Whether include expired overrides, default not include expired overrides'}, 'startTimestamp': {'type': 'int', 'position': 0, 'description': 'Records after this timestamp against fields defined by timeFieldStrategy'}, 'endTimestamp': {'type': 'int', 'position': 0, 'description': 'Records before this timestamp against fields defined by timeFieldStrategy'}, 'timeFieldStrategy': {'type': 'list', 'position': 0, 'description': 'TimeFieldStrategy to define which timestamp field(s) to match, default lastUpdatedTimestamp', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['lastUpdatedTimestamp', 'cutoff', 'all']}}, 'minValue': {'type': 'float', 'position': 0, 'description': 'Lower bound for override value range [0,1]'}, 'maxValue': {'type': 'float', 'position': 0, 'description': 'Upper bound for override data value range [0,1]'}, 'keywords': {'type': 'list', 'position': 0, 'description': 'Set of keywords to match selected fields, depends on KeywordMatchStrategy', 'uniqueItems': True, 'items': {'type': 'string'}}, 'keywordMatchStrategy': {'type': 'str', 'position': 0, 'description': 'Define whether all/any keywords have to be matched with selected fields', 'enum': ['all', 'any']}, 'timeMatchStrategy': {'type': 'str', 'position': 0, 'description': 'Defines how strict to match against different timestamps (all/any) using start and end timestamp (default any)', 'enum': ['all', 'any']}, 'domainPatternBases': {'type': 'list', 'position': 0, 'description': 'Collection of domain pattern bases', 'items': {'type': 'string'}}, 'keywordFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Define which field(s) to be matched against keywords', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['reason', 'domainPattern', 'all']}}, 'sortBy': {'type': 'list', 'position': 0, 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'items': {'type': 'str', 'enum': ['id', 'lastModified', 'domainPattern', '-id', '-lastModified', '-domainPattern']}}}, 'description': 'Search criteria for overrides for matching domains'}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'domainPattern': {'type': 'string'}, 'wildcardMatch': {'type': 'boolean'}, 'publicPrefixMatch': {'type': 'boolean'}, 'expired': {'type': 'boolean'}, 'deleted': {'type': 'boolean'}, 'flags': {'type': 'int', 'position': 0, 'description': 'Flags for the override entry'}, 'listName': {'type': 'str', 'position': 0, 'description': 'The name of the override list to which this override entry belongs.'}, 'data': {'type': 'dict', 'properties': {'value': {'type': 'float', 'position': 0, 'description': "The override entry's value."}, 'entryTime': {'type': 'int', 'position': 0, 'description': 'When the override entry was created.'}, 'reason': {'type': 'str', 'position': 0, 'description': 'The reason this override was created.'}, 'cutoff': {'type': 'int', 'position': 0, 'description': 'Time until which the override entry is valid.'}, 'userID': {'type': 'int', 'position': 0, 'description': 'DEPRECATED: Deprecated, use the user field.'}, 'user': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}}, 'description': 'Common data for an override entry.'}, 'defaultValue': {'type': 'bool', 'position': 0, 'description': 'Whether this override entry may be used as a default value'}, 'domainPatternBase': {'type': 'str', 'position': 0, 'description': "The domain name's pattern base"}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'When the override entry was last updated.', 'readOnly': True}}, 'description': 'A Domain Name entry in an override list.'}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation error'}}}
get_override_for_domain = {'tags': ['reputation/v1'], 'summary': 'Look up domain override value by ID (INTERNAL)', 'description': '', 'operationId': 'getOverrideForDomain', 'produces': ['application/json'], 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of override object', 'required': True, 'type': 'int', 'pattern': '[0-9]+'}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'domainPattern': {'type': 'string'}, 'wildcardMatch': {'type': 'boolean'}, 'publicPrefixMatch': {'type': 'boolean'}, 'expired': {'type': 'boolean'}, 'deleted': {'type': 'boolean'}, 'flags': {'type': 'int', 'position': 0, 'description': 'Flags for the override entry'}, 'listName': {'type': 'str', 'position': 0, 'description': 'The name of the override list to which this override entry belongs.'}, 'data': {'type': 'dict', 'properties': {'value': {'type': 'float', 'position': 0, 'description': "The override entry's value."}, 'entryTime': {'type': 'int', 'position': 0, 'description': 'When the override entry was created.'}, 'reason': {'type': 'str', 'position': 0, 'description': 'The reason this override was created.'}, 'cutoff': {'type': 'int', 'position': 0, 'description': 'Time until which the override entry is valid.'}, 'userID': {'type': 'int', 'position': 0, 'description': 'DEPRECATED: Deprecated, use the user field.'}, 'user': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}}, 'description': 'Common data for an override entry.'}, 'defaultValue': {'type': 'bool', 'position': 0, 'description': 'Whether this override entry may be used as a default value'}, 'domainPatternBase': {'type': 'str', 'position': 0, 'description': "The domain name's pattern base"}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'When the override entry was last updated.', 'readOnly': True}}, 'description': 'A Domain Name entry in an override list.'}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation error'}}}
get_override_for_ip = {'tags': ['reputation/v1'], 'summary': 'Look up IP override value by ID (INTERNAL)', 'description': '', 'operationId': 'getOverrideForIP', 'produces': ['application/json'], 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of override object', 'required': True, 'type': 'int', 'pattern': '[0-9]+'}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'expired': {'type': 'boolean'}, 'deleted': {'type': 'boolean'}, 'flags': {'type': 'int', 'position': 0, 'description': 'Flags for the override entry'}, 'listName': {'type': 'str', 'position': 0, 'description': 'The name of the override list to which this override entry belongs.'}, 'data': {'type': 'dict', 'properties': {'value': {'type': 'float', 'position': 0, 'description': "The override entry's value."}, 'entryTime': {'type': 'int', 'position': 0, 'description': 'When the override entry was created.'}, 'reason': {'type': 'str', 'position': 0, 'description': 'The reason this override was created.'}, 'cutoff': {'type': 'int', 'position': 0, 'description': 'Time until which the override entry is valid.'}, 'userID': {'type': 'int', 'position': 0, 'description': 'DEPRECATED: Deprecated, use the user field.'}, 'user': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}}, 'description': 'Common data for an override entry.'}, 'defaultValue': {'type': 'bool', 'position': 0, 'description': 'Whether this override entry may be used as a default value'}, 'range': {'type': 'dict', 'properties': {'fromAddress': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'public': {'type': 'boolean'}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}, 'toAddress': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'public': {'type': 'boolean'}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'When the override entry was last updated.', 'readOnly': True}}, 'description': 'An IP address entry in an Override List.'}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation error'}}}
get_override_list_by_id = {'tags': ['reputation/v1'], 'summary': 'Get override list by ID (INTERNAL)', 'description': '', 'operationId': 'getOverrideListByID', 'produces': ['application/json'], 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of OverrideList', 'required': True, 'type': 'int', 'minimum': 1, 'pattern': '[0-9]+'}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'defaultValues': {'type': 'boolean'}, 'lastModified': {'type': 'int', 'position': 0, 'description': 'The last time the Override List was updated.'}, 'name': {'type': 'str', 'position': 0, 'description': "The Override List's name. As it is globally unique it can be used to retrieve the Override List's metadata."}, 'description': {'type': 'str', 'position': 0, 'description': "The Override List's description."}}, 'description': 'A collection of override entries.'}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation error'}}}
get_override_lists = {'tags': ['reputation/v1'], 'summary': 'List all overrides (INTERNAL)', 'description': '', 'operationId': 'getOverrideLists', 'produces': ['application/json'], 'parameters': [{'name': 'offset', 'in': 'query', 'description': 'Skip a number of results', 'required': False, 'type': 'int', 'default': 0, 'minimum': 0}, {'name': 'limit', 'in': 'query', 'description': 'Maximum number of returned results', 'required': False, 'type': 'int', 'default': 25, 'minimum': 0}, {'name': 'keywords', 'in': 'query', 'description': 'Filter override lists by keywords', 'required': False, 'type': 'list', 'items': {'type': 'string'}, 'collectionFormat': 'multi'}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'defaultValues': {'type': 'boolean'}, 'lastModified': {'type': 'int', 'position': 0, 'description': 'The last time the Override List was updated.'}, 'name': {'type': 'str', 'position': 0, 'description': "The Override List's name. As it is globally unique it can be used to retrieve the Override List's metadata."}, 'description': {'type': 'str', 'position': 0, 'description': "The Override List's description."}}, 'description': 'A collection of override entries.'}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation error'}}}
get_overrides_for_domain = {'tags': ['reputation/v1'], 'summary': 'Look up domain override value by FQDN (INTERNAL)', 'description': '', 'operationId': 'getOverridesForDomain', 'produces': ['application/json'], 'parameters': [{'name': 'fqdn', 'in': 'path', 'description': 'Domain/domain pattern to fetch overrides for', 'required': True, 'type': 'str'}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'domainPattern': {'type': 'string'}, 'wildcardMatch': {'type': 'boolean'}, 'publicPrefixMatch': {'type': 'boolean'}, 'expired': {'type': 'boolean'}, 'deleted': {'type': 'boolean'}, 'flags': {'type': 'int', 'position': 0, 'description': 'Flags for the override entry'}, 'listName': {'type': 'str', 'position': 0, 'description': 'The name of the override list to which this override entry belongs.'}, 'data': {'type': 'dict', 'properties': {'value': {'type': 'float', 'position': 0, 'description': "The override entry's value."}, 'entryTime': {'type': 'int', 'position': 0, 'description': 'When the override entry was created.'}, 'reason': {'type': 'str', 'position': 0, 'description': 'The reason this override was created.'}, 'cutoff': {'type': 'int', 'position': 0, 'description': 'Time until which the override entry is valid.'}, 'userID': {'type': 'int', 'position': 0, 'description': 'DEPRECATED: Deprecated, use the user field.'}, 'user': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}}, 'description': 'Common data for an override entry.'}, 'defaultValue': {'type': 'bool', 'position': 0, 'description': 'Whether this override entry may be used as a default value'}, 'domainPatternBase': {'type': 'str', 'position': 0, 'description': "The domain name's pattern base"}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'When the override entry was last updated.', 'readOnly': True}}, 'description': 'A Domain Name entry in an override list.'}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation error'}}}
get_overrides_for_ip = {'tags': ['reputation/v1'], 'summary': 'Look up domain override value by IP address (INTERNAL)', 'description': '', 'operationId': 'getOverridesForIP', 'produces': ['application/json'], 'parameters': [{'name': 'ip', 'in': 'path', 'description': 'IP to search overrides for', 'required': True, 'type': 'str'}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'expired': {'type': 'boolean'}, 'deleted': {'type': 'boolean'}, 'flags': {'type': 'int', 'position': 0, 'description': 'Flags for the override entry'}, 'listName': {'type': 'str', 'position': 0, 'description': 'The name of the override list to which this override entry belongs.'}, 'data': {'type': 'dict', 'properties': {'value': {'type': 'float', 'position': 0, 'description': "The override entry's value."}, 'entryTime': {'type': 'int', 'position': 0, 'description': 'When the override entry was created.'}, 'reason': {'type': 'str', 'position': 0, 'description': 'The reason this override was created.'}, 'cutoff': {'type': 'int', 'position': 0, 'description': 'Time until which the override entry is valid.'}, 'userID': {'type': 'int', 'position': 0, 'description': 'DEPRECATED: Deprecated, use the user field.'}, 'user': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}}, 'description': 'Common data for an override entry.'}, 'defaultValue': {'type': 'bool', 'position': 0, 'description': 'Whether this override entry may be used as a default value'}, 'range': {'type': 'dict', 'properties': {'fromAddress': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'public': {'type': 'boolean'}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}, 'toAddress': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'public': {'type': 'boolean'}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'When the override entry was last updated.', 'readOnly': True}}, 'description': 'An IP address entry in an Override List.'}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation error'}}}
list_address_overrides = {'tags': ['reputation/v1'], 'summary': 'List address overrides (INTERNAL)', 'description': '', 'operationId': 'listAddressOverrides', 'produces': ['application/json'], 'parameters': [{'name': 'list', 'in': 'query', 'description': 'Limit results to overrides from this list', 'required': False, 'type': 'str'}, {'name': 'limit', 'in': 'query', 'description': 'Limit results', 'required': False, 'type': 'int', 'default': 25}, {'name': 'offset', 'in': 'query', 'description': 'Offset results', 'required': False, 'type': 'int', 'default': 0}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'expired': {'type': 'boolean'}, 'deleted': {'type': 'boolean'}, 'flags': {'type': 'int', 'position': 0, 'description': 'Flags for the override entry'}, 'listName': {'type': 'str', 'position': 0, 'description': 'The name of the override list to which this override entry belongs.'}, 'data': {'type': 'dict', 'properties': {'value': {'type': 'float', 'position': 0, 'description': "The override entry's value."}, 'entryTime': {'type': 'int', 'position': 0, 'description': 'When the override entry was created.'}, 'reason': {'type': 'str', 'position': 0, 'description': 'The reason this override was created.'}, 'cutoff': {'type': 'int', 'position': 0, 'description': 'Time until which the override entry is valid.'}, 'userID': {'type': 'int', 'position': 0, 'description': 'DEPRECATED: Deprecated, use the user field.'}, 'user': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}}, 'description': 'Common data for an override entry.'}, 'defaultValue': {'type': 'bool', 'position': 0, 'description': 'Whether this override entry may be used as a default value'}, 'range': {'type': 'dict', 'properties': {'fromAddress': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'public': {'type': 'boolean'}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}, 'toAddress': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'public': {'type': 'boolean'}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'When the override entry was last updated.', 'readOnly': True}}, 'description': 'An IP address entry in an Override List.'}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation error'}}}
list_domain_overrides = {'tags': ['reputation/v1'], 'summary': 'List domain overrides (INTERNAL)', 'description': '', 'operationId': 'listDomainOverrides', 'produces': ['application/json'], 'parameters': [{'name': 'list', 'in': 'query', 'description': 'Limit results to overrides from this list', 'required': False, 'type': 'str'}, {'name': 'limit', 'in': 'query', 'description': 'Limit results', 'required': False, 'type': 'int', 'default': 25}, {'name': 'offset', 'in': 'query', 'description': 'Offset results', 'required': False, 'type': 'int', 'default': 0}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'domainPattern': {'type': 'string'}, 'wildcardMatch': {'type': 'boolean'}, 'publicPrefixMatch': {'type': 'boolean'}, 'expired': {'type': 'boolean'}, 'deleted': {'type': 'boolean'}, 'flags': {'type': 'int', 'position': 0, 'description': 'Flags for the override entry'}, 'listName': {'type': 'str', 'position': 0, 'description': 'The name of the override list to which this override entry belongs.'}, 'data': {'type': 'dict', 'properties': {'value': {'type': 'float', 'position': 0, 'description': "The override entry's value."}, 'entryTime': {'type': 'int', 'position': 0, 'description': 'When the override entry was created.'}, 'reason': {'type': 'str', 'position': 0, 'description': 'The reason this override was created.'}, 'cutoff': {'type': 'int', 'position': 0, 'description': 'Time until which the override entry is valid.'}, 'userID': {'type': 'int', 'position': 0, 'description': 'DEPRECATED: Deprecated, use the user field.'}, 'user': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}}, 'description': 'Common data for an override entry.'}, 'defaultValue': {'type': 'bool', 'position': 0, 'description': 'Whether this override entry may be used as a default value'}, 'domainPatternBase': {'type': 'str', 'position': 0, 'description': "The domain name's pattern base"}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'When the override entry was last updated.', 'readOnly': True}}, 'description': 'A Domain Name entry in an override list.'}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation error'}}}
update_override_list = {'tags': ['reputation/v1'], 'summary': 'Update reputation override list (INTERNAL)', 'description': '', 'operationId': 'updateOverrideList', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of reputation override list', 'required': True, 'type': 'int', 'minimum': 1, 'pattern': '[0-9]+'}, {'in': 'body', 'name': 'body', 'description': 'Update override list request', 'required': False, 'schema': {'type': 'object', 'properties': {'id': {'type': 'int', 'position': 0, 'description': "The Override List's unique ID."}, 'name': {'type': 'str', 'position': 0, 'description': 'If set, update the name of this list => [a-zA-Z0-9_:\\-\\.]*'}, 'description': {'type': 'str', 'position': 0, 'description': 'If set, update the description of this list => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'useForReputationCalc': {'type': 'bool', 'position': 0, 'description': 'If set, enable/disable use of the overrides in this list when calculating reputation values'}, 'useForInputFiltering': {'type': 'bool', 'position': 0, 'description': 'If set, enable/disable use of the overrides in this list for observation input filtering'}, 'useForDefaultValues': {'type': 'bool', 'position': 0, 'description': 'If set, enable/disable use of the overrides in this list as default values'}}, 'description': 'Request to update an existing Override List.'}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'defaultValues': {'type': 'boolean'}, 'lastModified': {'type': 'int', 'position': 0, 'description': 'The last time the Override List was updated.'}, 'name': {'type': 'str', 'position': 0, 'description': "The Override List's name. As it is globally unique it can be used to retrieve the Override List's metadata."}, 'description': {'type': 'str', 'position': 0, 'description': "The Override List's description."}}, 'description': 'A collection of override entries.'}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation error'}}}
#: "get_override_for_i_p" is an alias for "get_override_for_ip"
get_override_for_i_p = get_override_for_ip
#: "get_overrides_for_i_p" is an alias for "get_overrides_for_ip"
get_overrides_for_i_p = get_overrides_for_ip